<?php

namespace app\api\controller;



use app\api\model\Gateway;

class Call extends Base
{
    /**
     * 发起视频语音通话（仅支持uniapp版本，不支持h5和web版本）
     */
    public function index()
    {
        $post = $this->_post();
        $event   = 'call';
        $id      = $post['id'];
        $channel = "user-$id";
        $room_id = $post['roomId'];
        /*if (!preg_match('/^[a-zA-Z0-9\-\_]$/', $room_id)) {
            return $this->json(1, '房间号非法');
        }*/
        $data = array_merge($post, [
            'caller'   => $_SESSION['userinfo']['uid'],
            'avatar'   => $_SESSION['userinfo']['avatar'],
            'nickname' => $_SESSION['userinfo']['nickname'],
        ]);
        Gateway::sendToGroup($channel, $event, $data);
        return $this->json(0);
    }

    /**
     * 收到通话请求（仅支持uniapp版本，不支持h5和web版本）
     */
    public function received()
    {
        $post = $this->_post();
        $event   = 'callReceived';
        $id      = $post['id'];
        $channel = "user-$id";
        Gateway::sendToGroup($channel, $event, []);
        return $this->json(0);
    }

    /**
     * 接受通话（仅支持uniapp版本，不支持h5和web版本）
     */
    public function accept()
    {
        $post = $this->_post();
        $event   = 'callAccept';
        $id      = $post['id'];
        $channel = "user-$id";
        Gateway::sendToGroup($channel, $event, []);
        return $this->json(0);
    }

    /**
     * 挂断通话（仅支持uniapp版本，不支持h5和web版本）
     */
    public function hangup()
    {
        $post = $this->_post();
        $event   = 'callHangUp';
        $id      = $post['id'];
        $channel = "user-$id";
        Gateway::sendToGroup($channel, $event, []);
        return $this->json(0);
    }
}
