<?php

namespace app\h5\controller;

use think\Db;

class User extends Base
{

    /**
     * 获得某个用户信息
     */
    public function detail()
    {
        if (empty($_GET['uid'])) {
            return $this->json(1, '缺少参数');
        }
        $user = new \app\api\controller\User();
        return $user->get();
    }

    /**
     * 获得某个用户信息
     */
    public function getbyname()
    {
        if (empty($_GET['username'])) {
            return $this->json(2, ' 非法参数');
        }
        $user = new \app\api\controller\User();
        return $user->get();
    }

    /**
     * 获得某个用户信息
     */
    public function getbyuid()
    {
        if (empty($_GET['uid'])) {
            return $this->json(2, ' 非法参数');
        }
        $user = new \app\api\controller\User();
        return $user->get();
    }

    /**
     * 更新用户信息
     */
    public function update()
    {
        $uid = $_SESSION['userinfo']['uid'];
        $user = Db::table('user')->where('uid', $uid)->find();
        if ($user && $user['account_state'] == 'disabled') {
            return $this->json(1, '当前用户无法完成此操作');
        }
        $user = new \app\api\controller\User();
        return $user->update();
    }

    /**
     * 更改密码
     */
    public function updatepassword() {
        $user = new \app\api\controller\User();
        return $user->updatepassword();
    }

    /**
     * 注销用户，删除该账户所有数据
     * @return null
     * @throws \think\Exception
     * @throws \think\exception\PDOException
     */
    public function delete()
    {
        if (!isset($_SESSION['userinfo'])) {
            return $this->json(0, 'ok');
        }
        $uid = $_SESSION['userinfo']['uid'];
        $password = $this->request->post('password');
        $password_md5 = Db::table('user')->where('uid', $uid)->value('password');
        if ($password_md5 !== md5($_SESSION['userinfo']['username'] . '-popim-' . $password)) {
            return $this->json(1, '密码不正确');
        }

        $user = Db::table('user')->where('uid', $uid)->find();
        if ($user && $user['account_state'] == 'disabled') {
            return $this->json(1, '当前用户无法完成此操作');
        }

        // 删除群组关系
        Db::table('group_member')->where('uid', $uid)->delete();

        // 删除好友关系
        Db::table('friend')->where(['uid' => $uid, 'friend_uid' => $uid])->delete();

        // 删除聊天记录
        Db::table('message')->where(['from' => $uid])->delete();
        Db::table('message')->where(['to' => $uid, 'type' => 'friend'])->delete();

        // 删除这个人发出的好友申请记录
        Db::table('notice')->where('from', $uid)->delete();

        // 删除用户信息
        Db::table('user')->where('uid', $uid)->delete();

        if (session_status() !== PHP_SESSION_ACTIVE) {
            session_start();
        }
        if (empty($_SESSION['userinfo'])) {
            return $this->json(0, 'ok');
        }

        $_SESSION = null;
        session_destroy();

        return $this->json(0, 'ok');
    }
}
