(function(){
    im = {
        data: {
            chatting: {},
            friend: [],
            group: [],
            mine: [],
            setting: [],
            show: "none",
            networkState: '',
            dataLoading: false,
            baseUri: '/im/h5/',
            api: {
                baseInfo: '/h5/pop/get',                                // 当前用户聚合数据
                deleteChat: '/h5/pop/delchat',                          // 删除会话
                userJoin: '/h5/login/join',                             // 注册接口
                userDetail: '/h5/user/detail',                          // 用户详情
                userUpdate: '/h5/user/update',                          // 更新用户接口
                updatePassword: '/h5/user/updatepassword',              // 更改密码
                getUserByName: '/h5/user/getbyname',                    // 通过登录名获得用户信息接口
                loginCheck: '/h5/login/check',                          // 登录接口
                loginCaptcha: '/h5/login/logincaptcha',                 // 登录验证码接口
                getSetting: '/h5/login/getsetting',                     // 获取配置
                logout: '/h5/login/logout',                             // 退出接口
                joinCaptcha: '/h5/login/joincaptcha',                   // 注册验证码
                messageSend: '/h5/message/send',                        // 发消息接口
                messageRevoke: '/h5/message/revoke',                    // 消息撤回接口
                messageGet: '/h5/message/get',                          // 获得历史消息接口
                messageUnreadCount: '/h5/message/unreadcount',          // 未读消息计数
                updateLastReadTime: '/h5/message/updateLastReadTime',   // 更新群组或者好友最后阅读消息时间
                uploadImage: '/h5/upload/img',                          // 上传图片接口
                uploadFile: '/h5/upload/file',                          // 上传文件接口
                uploadAvatar: '/h5/upload/avatar',                      // 上传头像接口
                friendList: '/h5/friend/getlist',                       // 好友列表
                friendApply: '/h5/friend/apply',                        // 发起好友申请接口
                friendApplyList: '/h5/friend/applylist',                // 好友申请列表接口
                friendApplyDetail: '/h5/friend/applydetail',            // 好友申请详情接口
                friendApplyCount: '/h5/friend/applycount',              // 未读好友申请数
                friendAgree: '/h5/friend/agree',                        // 同意好友申请接口
                friendRefuse: '/h5/friend/refuse',                      // 拒绝好友申请接口
                friendDelete: '/h5/friend/delete',                      // 好友删除接口
                friendRemark: '/h5/friend/remark',                      // 备注好友接口
                friendUpdate: '/h5/friend/update',                      // 更新好友信息接口
                groupCreate: '/h5/group/create',                        // 创建群组接口
                groupDetail: '/h5/group/detail',                        // 群组详情
                groupForbiddenUser: '/h5/group/forbiddenuser',          // 群组禁言接口
                groupForbiddenAll: '/h5/group/forbiddenall',            // 群组全员禁言
                groupLeave: '/h5/group/leave',                          // 离开群组接口
                groupDelete: '/h5/group/delete',                        // 删除或解散群组接口
                groupMemberAdd: '/h5/group/memberadd',                  // 群组增加群成员接口
                groupMemberDelete: '/h5/group/memberdel',               // 群组删除群成员接口
                groupMembers: '/h5/group/members',                      // 获得群成员接口
                groupRemark: '/h5/group/remark',                        // 备注群组接口
                groupUpdate: '/h5/group/update',                        // 更新群组信息接口
                groupMemberUpdate: '/h5/group/memberupdate',            // 更新群成员信息
                groupManager: '/h5/group/manager',                      // 设置为管理员
                groupIsManager: '/h5/group/ismanager',                  // 是否是管理员
                groupJoin: '/h5/group/join',                            // 加入群组，扫二维码进群使用
                qrcode: '/h5/qrcode/get',                               // 获得二维码
                authEndpoint: '/h5/push/auth'                           // socket通讯验证接口
            }
        },
        isback: false,
        connecter: null,
        show: function (module) {
            if (module != 'home' && module != 'login' && module != 'join' && module != 'language' && !im.data.mine.uid) {
                var path = im.context.path;
                page.replace(im.data.baseUri);
                im.redirectTo = path;
                return;
            }
            // 滑出效果
            if (im.isback && im.data.show != module) {
                var $last_module_html = $('#' + im.data.show);
                $last_module_html.addClass('pop__slide-out');
                $last_module_html.off('animationend webkitAnimationEnd');
                $last_module_html.on('animationend webkitAnimationEnd', function () {
                    $last_module_html.removeClass('pop__slide-out');
                    im.data.show = module;
                });
            } else {
                im.data.show = module;
            }
            // 滑入效果
            var $module_html = $('#' + module);
            if (!im.isback && ('home' != module)) {
                $module_html.addClass('pop__slide-in');
                $module_html.off('animationend webkitAnimationEnd');
                $module_html.on('animationend webkitAnimationEnd', function () {
                    $module_html.removeClass('pop__slide-in');
                    $module_html.css('display', 'block');
                });
            }
            im.isback = false;
        },
        chat: function (type, id) {
            chat.type = type;
            chat.id = id;
            page(im.data.baseUri + type + '/chat/' + id);
        },
        promptTone: function () {
            if (im.data.setting.prompt_tone != 'on' || im.data.mine.prompt_tone != 'on') return;
            document.getElementById("chat-message-audio").play();
            /*var audio = document.createElement("audio");
            audio.src = '/static/h5/sound/default.mp3';
            audio.play();*/
        },
        autoPlayPromptTone: function () {
            function a() {
                var e = document.getElementById("chat-message-audio-source").src
                    , b = document.getElementById("chat-message-audio");
                b.src = "";
                var p = b.play();
                p && p.then(function(){}).catch(function(e){});
                b.src = e;
                $(window).unbind("touchstart", a);
            }
            $(window).on("touchstart", a);
        },
        connect: function () {
            var wsAddress = im.data.setting.ws_address;
            im.connecter = new Subscriber({url:wsAddress});

            // 浏览器监听当前登录者的信息
            var user_channel = im.connecter.subscribe('user-' + im.data.mine.uid);

            // 监听群消息
            $.each(im.data.group, function (k, item) {
                im.listenGroup(item.gid);
            });

            // 监听成功后
            user_channel.on('success', function () {
                if (!im.lastUpdateTime) {
                    im.lastUpdateTime = new Date().getTime();
                    return;
                }
                var now = new Date().getTime();
                // 小于2秒则不更新
                if (now - im.lastUpdateTime < 2000) {
                    return;
                }
                home.syncData();
                im.lastUpdateTime = now;
                if (chat.type == 'group') {
                    im.syncGroup(chat.id, 1);
                }
            });

            // 当前用户接收到消息
            user_channel.on('message', im.onMessage);

            // 当前用户接收到撤回消息
            user_channel.on('revoke', im.revokeMessage);

            // 当前用户接收到加好友申请
            user_channel.on('friendApply', function (data) {
                im.promptTone();
                home.syncApplyCount();
                search.syncApplyList();
                // 创建推送消息
                if (im.hide) {
                    var options = {cover: false, title: Vue.prototype.$lang('好友申请')};
                    plus.push.createMessage(data.nickname + Vue.prototype.$lang(' 向你发起了好友申请'), {path: 'apply/detail/'+data.nid}, options);
                }
            });

            // 添加了一个好友
            user_channel.on('addFriend', function (data) {
                im.addFriend(data);
            });

            // 当前用户删除了一个好友
            user_channel.on('removeFriend', function (data) {
                im.deleteFriend(data.uid);
            });

            // 创建一个群组
            user_channel.on('addGroup', function (data) {
                im.listenGroup(data.gid);
            });

            user_channel.on('removeGroup', function (data) {
                im.deleteGroup(data.gid);
            });

            var global_channel = im.connecter.subscribe('global');
            global_channel.on('settingChange', function (data) {
                im.data.setting = data;
            });

            im.connecter.connection.on('state_change', function (states) {
                im.data.networkState = states.current;
            });
        },
        ajax: function (options) {
            var success_cb = options.success || false;
            var error_cb = options.error || false;
            var type = (options.type || 'get').toLowerCase();
            var tip = typeof options.tip == 'undefined' ? 2 : options.tip;
            var msg = typeof options.msg == 'undefined' ? 1 : options.msg;
            if (tip) {
                if (type == 'post') {
                    toast.dataPosting = 1;
                } else {
                    // 操作中
                    im.data.dataLoading = true;
                }
            } else {
                delete options.tip;
            }

            options.success = function (res) {
                if (type == 'post') {
                    if (tip > 1 && res.code == 0) {
                        // 操作成功
                        toast.dataPosting = 2;
                        setTimeout(function () {
                            toast.dataPosting = false;
                        }, 1000);
                    } else {
                        toast.dataPosting = false;
                    }
                } else {
                    im.data.dataLoading = false;
                }
                switch (res.code) {
                    // 需要登录
                    case -1:
                        im.redirectTo = false;
                        page.replace(im.data.baseUri + 'user/login');
                        return;
                    // 没有安装
                    case -2:
                        page(im.data.baseUri + 'user/login');
                        dialog.msg(res.msg);
                        return;
                }
                if (msg && res.code > 0) {
                    dialog.msg(res.msg);
                }
                success_cb && success_cb(res);
            };
            options.error = function (error) {
                if (type == 'post') {
                    toast.dataPosting = false;
                } else {
                    im.data.dataLoading = false;
                }
                error_cb && error_cb(error);
            };
            $.ajax(options);
        },
        onMessage: function (data) {
            var id = data.type == 'group' || data.from == im.data.mine.uid ? data.to : data.from;
            if (!im.data.chatting[data.type + id]) {
                im.addChatting({
                    id: id,
                    name: id == data.to ? data.to_name : data.from_name,
                    avatar: id == data.to ? data.to_avatar : data.from_avatar,
                    type: data.type,
                    unread_count: 0,
                    items: [],
                    top: data.top || 0
                });
            }

            var info = data.type == 'group' ? im.getGroupFromLocal(id) : im.getFriendFromLocal(id);
            info = info || {};
            for (var i in im.data.chatting[data.type + id].items) {
                if (data.mid == im.data.chatting[data.type + id].items[i].mid) {
                    return;
                }
            }

            var items = im.data.chatting[data.type + id].items;
            var included = 0;
            for (var j in items) {
                var item = items[j];
                if (data.uniqueId && data.uniqueId == item.uniqueId) {
                    item.mid = data.mid;
                    included = 1;
                    break;
                }
                if (data.mid == item.mid) {
                    included = 1;
                }
            }
            if (!included) {
                im.data.chatting[data.type + id].items.push({
                    mid: data.mid,
                    from: data.from,
                    name: info.remark || data.from_name,
                    to: data.to,
                    avatar: data.from_avatar,
                    content: data.content,
                    timestamp: data.timestamp,
                    sub_type: data.sub_type || 'message'
                });
            }

            chat.scrollBottom(true);

            if (data.type == 'group' && data.from != im.data.mine.uid && data.sub_type != 'notice' && im.data.show == 'chat' && chat.type == data.type && chat.id == id) {
                var reg = new RegExp('@\\[.*?\\]\\('+im.data.mine.uid+'\\)');
                if (reg.test(data.content)) {
                    //im.syncGroup(id, 1);
                    for (var key in im.data.group) {
                        var group = im.data.group[key];
                        if (group.gid == id) {
                            group.at = {
                                mid : data.mid,
                                from_name : data.from_name,
                                content : data.content
                            };
                        }
                    }
                }
            }

            // 增加红点儿计数
            if (data.from != im.data.mine.uid && data.sub_type != 'notice' && (im.data.show != 'chat' || chat.type != data.type || chat.id != id)) {
                if (im.data.chatting[data.type + id].unread_count != '99+') {
                    im.data.chatting[data.type + id].unread_count++;
                    if (im.data.chatting[data.type + id].unread_count >= 100) im.data.chatting[data.type + id].unread_count = '99+';
                }
            }
            // 播放提示音
            if (data.from != im.data.mine.uid && data.sub_type != 'notice') {
                im.promptTone();
                if (im.hide) {
                    var options = {cover: false, title: data.type=='friend' ? data.from_name : data.to_name};
                    console.log('/'+data.type+'/chat/'+data.type=='friend' ? data.from : data.to);
                    plus.push.createMessage(data.content, {path: '/'+data.type+'/chat/'+(data.type=='friend' ? data.from : data.to)}, options);
                }
            }
        },
        revokeMessage: function (data) {
            var type = data.type;
            var id = type != 'friend' || data.uid == im.data.mine.uid ? data.id : data.uid;
            var mid = data.mid;
            if (im.data.chatting[type + id]) {
                if (im.data.chatting[type + id].items) {
                    for (var index in im.data.chatting[type + id].items) {
                        var item = im.data.chatting[type + id].items[index];
                        if (item.mid == mid) {
                            im.data.chatting[type + id].items[index].sub_type = 'notice';
                            im.data.chatting[type + id].items[index].content = Vue.prototype.$lang('此消息已撤回');
                            return;
                        }
                    }
                }
            }
        },
        syncChatting: function (type, id) {
            if (!id) {
                console.trace('id undefined');
                return;
            }
            var item = type == 'friend' ? im.getFriendFromLocal(id) : im.getGroupFromLocal(id);
            if (!item) {
                im.addChatting({
                    id: id,
                    type: type
                });
                im.ajax({
                    url: type == 'friend' ? im.data.api.userDetail : im.data.api.groupDetail,
                    type: 'get',
                    data: {uid: id, gid: id, simple:1},
                    success: function (res) {
                        if (res.code == 0) {
                            im.addChatting({
                                id: id,
                                name: type == 'friend' ? res.data.remark || res.data.nickname : res.data.remark || res.data.groupname,
                                avatar: res.data.avatar,
                                type: type
                            });
                        }
                    }
                });
            } else {
                item = {
                    id: id,
                    name: item.name,
                    avatar: item.avatar,
                    type: type
                };
                im.addChatting(item);
                return item;
            }
        },
        addChatting: function (data) {
            // 更新数据库为chatting状态
            if (!im.data.chatting[data.type + data.id]) {
                Vue.set(im.data.chatting, data.type + data.id, {
                    id: data.id,
                    name: data.name,
                    avatar: data.avatar,
                    type: data.type,
                    unread_count: data.unread_count || 0,
                    items: data.items || [],
                    top: data.top || 0
                });
            } else {
                $.each(im.data.chatting[data.type + data.id], function (k, v) {
                    if (typeof data[k] != 'undefined') {
                        im.data.chatting[data.type + data.id][k] = data[k];
                    }
                });
            }

            im.syncUnreadCount(data.type, data.id);
        },
        deleteChatting: function (type, id) {
            if (im.data.chatting[type + id]) {
                Vue.delete(im.data.chatting, type + id);
            }
            if (im.data.show == 'chat' && chat.type == type && chat.id == id) {
                history.back();
            }
        },
        syncSetting: function  () {
            im.ajax({
                url: im.data.api.getSetting,
                success: function (res) {
                    if (res.code == 0) {
                        im.data.setting = res.data;
                        document.title = res.data.app_name;
                    }
                }
            });
            // 加载语言
            home.syncLang();
        },
        syncUnreadCount: function (type, id) {
            im.ajax({
                url: im.data.api.messageUnreadCount,
                type: 'get',
                data: {type: type, id: id},
                success: function (res) {
                    if (res.code == 0) {
                        if (im.data.chatting[type + id]) {
                            im.data.chatting[type + id]['unread_count'] = res.data;
                        }
                    }
                }
            });
        },
        syncUser: function (uid) {
            im.ajax({
                url: im.data.api.userDetail,
                type: 'get',
                data: {uid: uid},
                success: function (res) {
                    if (res.code == 0) {
                        $.each(im.data.friend, function(char, items){
                            if (items[uid]) {
                                im.data.friend[char][uid].name = res.data.remark || res.data.nickname;
                                im.data.friend[char][uid].avatar = res.data.avatar;
                            }
                        });
                        if (im.data.chatting['friend'+uid]) {
                            im.data.chatting['friend'+uid].avatar = res.data.avatar;
                            im.data.chatting['friend'+uid].name = res.data.remark || res.data.nickname;
                        }
                    }
                }
            });
        },
        syncGroup: function (gid, with_at) {
            if (!with_at) with_at = undefined;
            im.ajax({
                url: im.data.api.groupDetail,
                type: 'get',
                data: {gid: gid, simple:1, at: with_at},
                success: function (res) {
                    if (res.code == 0) {
                        var in_group = false;
                        $.each(im.data.group, function(index, item) {
                            if (item.gid == gid) {
                                im.data.group[index].name = res.data.remark || res.data.groupname;
                                im.data.group[index].avatar = res.data.avatar;
                                im.data.group[index].uid = res.data.uid;
                                if (res.data.at) {
                                    Vue.set(im.data.group[index], 'at', res.data.at);
                                }
                                im.data.group[index].notice = res.data.notice;
                                im.data.group[index].notice_readed = res.data.notice_readed;
                                im.data.group[index].is_manager = res.data.is_manager;
                                in_group = true;
                            }
                        });
                        if (!in_group) {
                            var item = {
                                gid : gid,
                                avatar : res.data.avatar,
                                name : res.data.remark || res.data.groupname,
                                uid: res.data.uid,
                                notice: res.data.notice,
                                notice_readed: res.data.notice_readed,
                                is_manager: res.data.is_manager
                            };
                            if (res.data.at) {
                                item.at = res.data.at;
                            }
                            im.data.group.push(item);
                        }
                        if (im.data.chatting['group'+gid]) {
                            im.data.chatting['group'+gid].avatar = res.data.avatar;
                            im.data.chatting['group'+gid].name = res.data.remark || res.data.groupname;
                        }
                    }
                }
            });
        },
        addFriend: function (data) {
            im.addChatting({
                id: data.uid,
                name: data.name,
                avatar: data.avatar,
                type: 'friend',
                key: 'friend' + data.uid,
                unread_count: 0,
                items: [],
                top: data.top || 0
            });
            im.syncAddress();
        },
        updateGroup: function (gid, data) {
            if (im.data.chatting['group' + gid]) {
                for (var k in data) {
                    if (typeof im.data.chatting['group' + gid][k] != 'undefined') {
                        Vue.set(im.data.chatting['group' + gid], k, data[k]);
                    }
                }
            }
            for (var index in im.data.group) {
                var item = im.data.group[index];
                if (item.gid == gid) {
                    for (var k in data) {
                        if (typeof item[k] != 'undefined') {
                            Vue.set(im.data.group[index], k, data[k]);
                        }
                    }
                }
            };
        },
        updateFriend: function (uid, data) {
            if (im.data.chatting['friend' + uid]) {
                for (var k in data) {
                    if (typeof im.data.chatting['friend' + uid][k] != 'undefined') {
                        Vue.set(im.data.chatting['friend' + uid], k, data[k]);
                    }
                }
            }
            im.syncAddress();
        },
        deleteFriend: function (uid) {
            im.deleteChatting('friend', uid);
            im.deleteFriendFromLocal(uid);
        },
        deleteGroup: function (gid) {
            im.unlistenGroup(gid);
            im.deleteChatting('group', gid);
            im.deleteGroupFromLocal(gid);
        },
        syncAddress: function (callback) {
            im.ajax({
                url: im.data.api.friendList,
                type: 'get',
                success: function (res) {
                    if (res.code == 0) {
                        Vue.set(im.data, 'friend', res.data);
                    }
                    if (callback) {
                        callback.call(this);
                    }
                }
            });
        },
        getFriendFromLocal: function (uid) {
            for (var char in im.data.friend) {
                var items = im.data.friend[char];
                if (items[uid]) return items[uid];
            }
        },
        deleteFriendFromLocal: function (uid) {
            for (var char in im.data.friend) {
                var items = im.data.friend[char];
                if (items[uid]) {
                    Vue.delete(im.data.friend[char], uid);
                    if (!Object.values(im.data.friend[char]).length) {
                        Vue.delete(im.data.friend, char);
                    }
                    return;
                }
            }
        },
        getGroupFromLocal: function (gid) {
            for (var key in im.data.group) {
                if (im.data.group[key].gid == gid) return im.data.group[key];
            }
            return {};
        },
        deleteGroupFromLocal: function (gid) {
            for (var key in im.data.group) {
                if (im.data.group[key].gid == gid) {
                    Vue.delete(im.data.group, key);
                    return;
                }
            }
        },
        listenGroup: function (gid) {
            var key = 'group-' + gid;
            if (im.connecter.channels[key]) {
                return;
            }
            var group_channel = im.connecter.subscribe(key);
            group_channel.on('message', im.onMessage);
            group_channel.on('updateGroup', function (data) {
                var gid = data.gid;
                im.updateGroup(gid, data);
            });
            group_channel.on('removeGroup', function (data) {
                im.deleteGroup(data.gid);
            });
            group_channel.on('update', function (data) {
                im.updateGroup(gid, data);
            });
            group_channel.on('revoke', im.revokeMessage);
        },
        unlistenGroup: function (gid) {
            im.connecter.unsubscribe('group-' + gid);
        },
        check: function (ctx) { // 如果设置了backToPath，则一直后退到backToPath地址
            if (im.backToPath) {
                if (im.backToPath.charAt(im.backToPath.length - 1) == '/') {
                    im.backToPath = im.backToPath.substr(0, im.backToPath.length - 1);
                }
                if (im.backToPath != ctx.path && im.backToPath+'/' != ctx.path) {
                    console.log('backToPath:' + im.backToPath);
                    history.back();
                    return false;
                }
                im.backToPath = '';
            }
            im.context = ctx;
            return true;
        },
        setting: function (title, desc, content, btn_name, callback) {
            setting.title = title;
            setting.desc = desc;
            setting.btn_name = btn_name;
            setting.content = im.htmlDecode(content);
            setting.callback = callback ? callback : null;
            im.show('setting');
        },
        autoUpdateTime: function () {
            $.each($('.pop__time'), function (key, item) {
                var $item = $(item);
                $item.html(Vue.prototype.$formatTime(($item.attr('value'))));
            });
        },
        checkUsername: function (name) {
            var reg = /^[A-Za-z0-9]{1,60}$/;
            return reg.test(name);
        },
        isDangerousUrl: function (url) {
            url = url.toLowerCase();
            // url不允许有javascript关键字
            if (url.indexOf('javascript') != -1) return true;
            // url里必须以/或http或https开头
            if (url.indexOf('/') != 0 && url.indexOf('http') != 0 && url.indexOf('http') != 0) return true;
            return false;
        },
        textContent: function (content) {
            content = content.replace(/\[表情\d+\]/g, '['+Vue.prototype.$lang('表情')+']').replace(/@\[(.+?)\]\((\d+)\)/g, '<em>@$1</em>');
            if (/^audioCall\[\]$/.test(content)) {
                content = '['+Vue.prototype.$lang('语音通话')+']';
            } else if (/^videoCall\[\]$/.test(content)) {
                content = '['+Vue.prototype.$lang('视频通话')+']';
            } else if (/\!\[.*?\]\(([^\)]+?)\)/.test(content)) {
                content = '['+Vue.prototype.$lang('图片')+']';
            } else if (/^voice\[\d+\]\(([^\)]+?)\)$/.test(content)) {
                content = '['+Vue.prototype.$lang('语音')+']';
            } else if (/^voice\(([^\)]+?)\)$/.test(content)) {
                content = '['+Vue.prototype.$lang('语音')+']';
            } else if (/^file\[(.*?)[\t|\|](.*?)]\((.+?)\)$/.test(content)) {
                content = '['+Vue.prototype.$lang('文件')+']';
            } else if (/\[.*?\]\(([^\)]+?)\)/.test(content)) {
                // 替换a连接
                content = content.replace(/\[(.*?)\]\(([^\)]+?)\)/g, '$1');
            }
            return content;
        },
        htmlEncode: function (html) {
            var map =
                    {
                            '&': '&amp;',
                            '<': '&lt;',
                            '>': '&gt;',
                            '"': '&quot;',
                            "'": '&#039;'
                    };
                    return html.replace(/[&<>"']/g, function(m) {return map[m];});
        },
        htmlDecode: function (text) {
            var map =
                    {
                            '&amp;': '&',
                            '&lt;': '<',
                            '&gt;': '>',
                            '&quot;': '"',
                            '&#039;': "'"
                    };
                    return text.replace(/&amp;|&lt;|&gt;|&quot;|&#039;/g, function(m) {return map[m];});
        },
        nl2br: function (text) {
            return text.replace(/\n/g, "<br>");
        },
        scrollIntoView: function (letter) {
            var char = letter;
            letter = letter == '#' ? 'other' : letter;
            $.each($('.pop__firend_list_' + letter), function (k, item) {
                item.scrollIntoView();
            });

            $(".pop__friend-list-showletter").text(char).fadeIn(300);
            setTimeout(function () {
                $(".pop__friend-list-showletter").fadeOut(300);
            }, 500);
        },
        resizeWindow: function () {
            var h = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
            var remh = parseFloat(document.documentElement.style.fontSize);
            im.rem = remh;
            im.height = h;
            $('.pop__chat-wrapper').css('height', h);
            $('.pop__main-page').css('height', h);
            $('.pop__body').css('height', h - 2.1 * remh);
        },
        domain: function () {
            var ishttps = 'https:' == document.location.protocol ? true : false;
            var url = window.location.host;
            if (ishttps) {
                domain = 'https://' + url;
            } else {
                domain = 'http://' + url;
            }
            return domain;
        },
        supportH5Plus: function () {
            if (typeof plus != 'undefined' && plus.audio && plus.uploader && plus.os.name != 'Android') {
                return true;
            }
            return false;
        }
    };

    var welcome = new Vue({
        'el': '#welcome',
        data: {
            im: im.data
        }
    });

    // 主面板
    var home = new Vue({
        el: '#home',
        data: {
            im: im.data,
            tab: "chatting",
            unreadApplyCount: 0,
            slideDistance: 0,
            explore_url: ''
        },
        watch: {
            tab: function (new_value, old_value) {
                // 同步im.friend
                if (new_value == 'friend' && !this.hasSyncAddress) {
                    im.syncAddress();
                    this.hasSyncAddress = true;
                }

                if (new_value == 'explore') {
                   if (!this.explore_url) {
                        this.explore_url = im.data.setting.explore_url;
                   }
                }
            }
        },
        computed: {
            unreadMessageCount: function () {
                var count = 0;
                $.each(im.data.chatting, function (k, item) {
                    if (count == '99+') return;
                    if (item.unread_count == '99+') {
                        count = '99+';
                        return;
                    }
                    count += item.unread_count;
                });
                return count;
            },
            chattingItems: function () {
                return Object.values(this.im.chatting).sort(function (a, b) {
                    var item_a = a.items.length && a.items.slice(-1)[0];
                    var item_b = b.items.length && b.items.slice(-1)[0];
                    var top_a = a.top ? 1 : 0;
                    var top_b = b.top ? 1 : 0;
                    if (top_a != top_b) {
                        return ((top_a > top_b) ? -1 : 1);
                    }
                    var time_a = item_a && item_a.timestamp ? item_a.timestamp : 0;
                    var time_b = item_b && item_b.timestamp ? item_b.timestamp : 0;
                    return ((time_a > time_b) ? -1 : (time_a < time_b) ? 1 : 0);
                });
            },
            stateName: function () {
                var map = {
                    initialized: '',
                    established: '',
                    connected: '',
                    connecting: Vue.prototype.$lang('连接中...'),
                    wait_reconnect: Vue.prototype.$lang('连接中...'),
                    unavailable: Vue.prototype.$lang('网络暂时不可用，稍后重试'),
                    failed: Vue.prototype.$lang('连接断开，请点击刷新'),
                    closed: Vue.prototype.$lang('连接中...')
                };
                return map[im.data.networkState] || '';
            }
        },
        methods: {
            refresh: function () {
                window.location.reload();
            },
            syncData: function (simple) {
                var now = new Date().getTime();
                // 小于2秒则不更新
                if (now - im.lastUpdateTime < 2000) {
                    console.log('syncData return without ajax');
                    return;
                }
                im.lastUpdateTime = now;
                var data = {};
                if (simple) {
                    data.simple = 1;
                }
                im.ajax({
                    url: im.data.api.baseInfo,
                    type: 'get',
                    data: data,
                    success: function (res) {
                        switch (res.code) {
                            // 获取用户信息成功
                            case 0:
                                im.data.mine = res.data.mine;
                                if (simple) {
                                    return;
                                }
                                $.each(res.data.chatting, function (key, chatting_item) {
                                    var items = im.data.chatting[key] ? im.data.chatting[key].items : [];
                                    Vue.set(im.data.chatting, key, chatting_item);
                                    if (!items.length || !chatting_item.items.length) {
                                        return;
                                    }
                                    var max_mid = chatting_item.items[0].mid;
                                    if (max_mid > items[items.length - 1]['mid']) {
                                        items.push(chatting_item.items[0]);
                                    }
                                    im.data.chatting[key].items = items;
                                });
                                chat.getmessage(true, null, true);
                                //im.data.friend = res.data.friend;
                                this.hasSyncAddress = false;
                                im.data.group = res.data.group;
                                im.data.setting = res.data.setting;
                                home.unreadApplyCount = res.data.mine.unread_friend_apply_count;
                                document.title = res.data.setting.app_name;
                                if (!im.connectionInited) {
                                    im.connectionInited = true;
                                    im.connect();
                                }
                                if (home.tab == 'friend') {
                                    im.syncAddress();
                                    this.hasSyncAddress = true;
                                }
                                if (im.redirectTo) {
                                    page(im.redirectTo);
                                    im.redirectTo = '';
                                }
                                return;
                            case 101:
                                // 用户不存在，走转登录
                                page(im.data.baseUri + 'user/login');
                                return;
                        }
                    }
                });
            },
            syncLang: function () {
                Vue.set(im.data, 'language', localStorage.getItem('language') || 'zh-CN');
                im.ajax({
                    url: '/lang.json',
                    type: 'get',
                    success: function (res) {
                        Vue.set(im.data, 'lang', res);
                    }
                });
            },
            syncApplyCount: function () {
                im.ajax({
                    url: im.data.api.friendApplyCount,
                    type: 'get',
                    success: function (res) {
                        if (res.code == 0) {
                            home.unreadApplyCount = res.data;
                        }
                    }
                });
            },
            lastMessage: function (item) {
                item = item.items.length && item.items.slice(-1)[0];
                if (!item) {
                    return {
                        content: '',
                        timestamp: 0
                    };
                }
                return {
                    content: im.textContent(item['content']),
                    timestamp: item['timestamp']
                };
            },
            //滑动开始
            touchStart: function (e, item) {
                // 记录初始位置
                item.startX = e.touches[0].clientX;
                item.startY = e.touches[0].clientY;
                this.restSlide(item);
            },
            touchMove: function (e, item) {
                var currX = e.changedTouches[0].clientX;
                var currY = e.changedTouches[0].clientY;
                // 判断是左右滑动还是上下滚动
                if (!item.direction) {
                    if (Math.abs(currX - item.startX) > Math.abs(currY - item.startY)) {
                        item.direction = 'left-right';
                    } else {
                        item.direction = 'up-down';
                    }
                }
                if (item.direction == 'up-down') {
                    return;
                }
                var diff = ((currX - item.startX) * -1) / im.rem;
                // 已经在最右侧，不允许再向右侧滑动
                if (!item.slideDistance && diff < 0) {
                    return;
                    // 已经在最左侧，不允许再向左侧滑动
                } else if (item.slideDistance == 3 && diff > 0) {
                    return;
                }
                if (diff > 0) {
                    Vue.set(item, 'slideDistance', diff > 3 ? 3 : diff);
                } else {
                    Vue.set(item, 'slideDistance', diff < -3 ? 0 : 3 + diff);
                }
                e.preventDefault();
            },
            //滑动结束
            touchEnd: function (e, item) {
                if (item.direction == 'left-right') {
                    // 记录结束位置
                    var endX = e.changedTouches[0].clientX;
                    // 左滑
                    if (item.startX - endX > 30) {
                        Vue.set(item, 'slideDistance', 3);
                    } else {
                        Vue.set(item, 'slideDistance', 0);
                    }
                    // 右滑
                    if (item.startX - endX < -30) {
                        Vue.set(item, 'slideDistance', 0);
                    }
                }
                item.direction = false;
                item.startX = 0;
                item.startY = 0;
            },
            //复位滑动状态
            restSlide: function (except) {
                $.each(this.chattingItems, function (v, item) {
                    if (except == item) {
                        return;
                    }
                    Vue.set(item, 'slideDistance', 0);
                });
            },
            //删除
            deleteItem: function (event, item) {
                im.ajax({
                    url: im.data.api.deleteChat,
                    type: 'post',
                    data: {type: item.type, id: item.id},
                    success: function (res) {
                        if (res.code == 0) {
                            im.deleteChatting(item.type, item.id);
                        }
                    }
                });
            },
            // 置顶/取消置顶
            switchTop: function (event, item) {
                var top = im.data.chatting[item.type + item.id].top ? 0 : 1;
                if (item.type == 'friend') {
                    im.ajax({
                        url: im.data.api.friendUpdate,
                        type: 'post',
                        data: {friend_uid: item.id, top: top},
                        success: function (res) {
                            if (res.code == 0) {
                                im.data.chatting[item.type + item.id].top = top;
                            }
                        }
                    });
                } else {
                    im.ajax({
                        url: im.data.api.groupMemberUpdate,
                        type: 'post',
                        data: {gid: item.id, top: top},
                        success: function (res) {
                            if (res.code == 0) {
                                im.data.chatting[item.type + item.id].top = top;
                            }
                        }
                    });
                }
                item.slideDistance = 0;
            },
            toggleTopBar: function () {
                $('.pop__topbar-menu').toggle();
                $('.pop__topbar-mask').toggle();
            },
            scrollIntoView: im.scrollIntoView
        }
    });

    var homepage = function (ctx) {
        if (!im.check(ctx))return;
        // 没登录尝试获取用户信息
        if (!im.data.mine.uid) {
            // 加载语言
            home.syncLang();
            // 获取登录用户所有信息
            home.syncData();
        }
        im.show('home');
    };

    // 主面板页面
    page(im.data.baseUri, homepage);

    // 退出主面板页面
    page.exit(im.data.baseUri, function (ctx, next) {
        $('.pop__topbar-menu').hide();
        $('.pop__topbar-mask').hide();
        next();
    });

    // 登录
    var login = new Vue({
        el: '#login',
        data: {
            im: im.data,
            username: '',
            password: '',
            captcha: ''
        },
        methods: {
            login: function () {
                if (this.username == '') {
                    return dialog.msg(this.$lang('用户名不能为空'));
                } else if (this.password == '') {
                    return dialog.msg(this.$lang('密码不能为空'));
                } else if (im.data.setting.login_captcha == 'on' && this.captcha == '') {
                    return dialog.msg(this.$lang('验证码不能为空'));
                } else {
                    var that = this;
                    var data = {username: this.username, password: this.password, captcha: this.captcha};
                    if (typeof plus != 'undefined' && plus.push) {
                        var client_info = plus.push.getClientInfo();
                        data.cid = client_info.clientid;
                    }
                    im.ajax({
                        url: im.data.api.loginCheck,
                        type: 'post',
                        tip: 0,
                        data: data,
                        success: function (res) {
                            if (res.code == 0) {
                                page.replace(im.data.baseUri);
                            } else {
                                that.switchCaptcha();
                            }
                        }
                    });
                }
            },
            switchCaptcha: function () {
                if (im.data.setting.login_captcha == 'on') {
                    this.$refs.captchaImg.src = im.data.api.loginCaptcha + '?rand=' + Math.random();
                }
            }
        }
    });

    // 注册
    var join = new Vue({
        el: '#join',
        data: {
            im: im.data,
            username: '',
            nickname: '',
            password: '',
            sign: '',
            captcha: ''
        },
        methods: {
            join: function () {
                if (this.username == '') {
                    return dialog.msg(this.$lang('用户名不能为空'));
                } else if (this.nickname == '') {
                    return dialog.msg(this.$lang('昵称不能为空'));
                } else if (this.password == '') {
                    return dialog.msg(this.$lang('密码不能为空'));
                } else if (im.data.setting.register_captcha == 'on' && this.captcha == '') {
                    return dialog.msg(this.$lang('验证码不能为空'));
                } else {
                    if (!im.checkUsername(this.username)) {
                        return dialog.msg(this.$lang('用户名只能包含字母和数字，长度小于60'));
                    }
                    var that = this;
                    im.ajax({
                        url: im.data.api.userJoin,
                        type: 'post',
                        tip: 0,
                        data: {
                            username: this.username,
                            password: this.password,
                            nickname: this.nickname,
                            sign: this.sign,
                            captcha: this.captcha
                        },
                        success: function (res) {
                            if (res.code == 0) {
                                page.replace(im.data.baseUri + 'user/login');
                                return;
                            } else {
                                that.switchCaptcha();
                            }
                        }
                    });
                }
            },
            switchCaptcha: function () {
                if (im.data.setting.register_captcha == 'on') {
                    this.$refs.captchaImg.src = im.data.api.joinCaptcha + '?rand=' + Math.random();
                }
            }
        }
    });


    // 私聊页面
    page(im.data.baseUri + 'friend/chat/:uid', function (ctx) {
        if (!im.check(ctx))return;
        chat.id = ctx.params.uid;
        chat.type = 'friend';
        im.show('chat');
        im.syncUser(chat.id);
        chat.getmessage(true, null, true);
    });

    // 群聊页面
    page(im.data.baseUri + 'group/chat/:gid', function (ctx) {
        if (!im.check(ctx))return;
        chat.id = ctx.params.gid;
        chat.type = 'group';
        im.show('chat');
        im.syncGroup(chat.id, 1);
        chat.getmessage(true, null, true);
    });

    // 聊天面板
    var chat = new Vue({
        el: '#chat',
        data: {
            im: im.data,
            id: 0,
            type: 'friend',
            message: '',
            voice: false,
            panel: false,
            voiceTips: '',
            voiceBtnTips: '',
            messageLock: false,
            messageEnd: false,
            tapMenuShow: false,
            tapMenuLeft: 0,
            tapMenuTop: 0,
            supportRevoke: false,
            showNotice: 0
        },
        watch: {
            message: function (new_message, old_message) {
                if (new_message.length > old_message.length && chat.type == 'group' && (new_message == '@' || /[^\d,^a-z,^A-Z]@$/.test(new_message))) {
                    chat.$refs.input.blur();
                    this.showAtSelection();
                }
            }
        },
        computed: {
            messageList: function () {
                this.lastInsertTime = this.lastTime = 0;
                if (!this.im.chatting[this.type + this.id]) {
                    return [];
                }
                return this.im.chatting[this.type + this.id]['items'] || [];
            },
            name: function () {
                if (!this.id) return '';
                var item = this.im.chatting[this.type + this.id] || false;
                return item ? item.remark || item.name : '';
            },
            atContent: function () {
                if (!this.id || this.type != 'group') return {};
                for (var key in im.data.group) {
                    var group = im.data.group[key];
                    if (group.gid == this.id) {
                        var at = group.at ? group.at : {};
                        if (at.content) {
                            at.content = im.textContent(at.content);
                        }
                        return at;
                    }
                }
                return {};
            },
            inputWidth: function () {
                var width = 6.1;
                if (this.im.setting.voice == 'on') {
                    width -= 0.88;
                }
                if (this.im.setting.emoji == 'on') {
                    width -= 0.88;
                }
                return width + 'rem';
            },
            mid: function () {
                var messageList = this.im.chatting[this.type + this.id];
                if (!messageList || !messageList.items || !messageList.items.length) {
                    return null;
                }
                return messageList.items[0]['mid'] || null;
            },
            notice: function () {
                if (!this.id || this.type != 'group') return {content: '', readed: 1};
                for (var key in im.data.group) {
                    var group = im.data.group[key];
                    if (group.gid == this.id) {
                        return {content: group.notice || '', readed: group.notice_readed};
                    }
                }
                return {content: '', readed: 1};
            },
            nl2brNotice: function () {
                return im.nl2br(this.notice.content);
            },
            supportCopy: function () {
                return typeof document.execCommand == 'function';
            }
        },
        methods: {
            reset: function () {
                // 更新最后阅读时间
                im.ajax({
                    url: im.data.api.updateLastReadTime,
                    type: 'post',
                    tip: 0,
                    data: {
                        id: this.id,
                        type: this.type
                    }
                });
                if (this.im.chatting[this.type + this.id] && this.im.chatting[this.type + this.id]['items']) {
                    this.im.chatting[this.type + this.id].items = this.im.chatting[this.type + this.id].items.slice(-20);
                    this.im.chatting[this.type + this.id].unread_count = 0;
                }
                this.voiceTips = this.message = '';
                this.messageEnd = this.messageLock = this.panel = this.voice = this.showNotice = false;
                this.voiceBtnTips = this.$lang('按住 说话');
                this.lastTime = this.lastInsertTime = 0;
            },
            needInsertTime: function (timestamp) {
                if (timestamp < this.lastTime) {
                    this.lastInsertTime = 0;
                }
                this.lastTime = timestamp;
                if (new Date().getTime() > timestamp && timestamp - this.lastInsertTime > 60) {
                    this.lastInsertTime = timestamp;
                    return true;
                }
                return false;
            },
            emojiList: function() {
                var emoji_list = [
                    ['😀','😄','😆','😂','😇','😉','😊','🙂','😋','😌','😍','😘','😗','😝','🤑','😎','🤓','🤗','😶','😑','🙄'],
                    ['🤔','😳','😡','🙁','😬','😣','😩','😤','😱','😰','😢','😓','😭','😵','🤐','😷','😴','💤','😈','💩','👻'],
                    ['💀','🤖','🎃','😹','🙀','👏','🙏','👍','👎','👊','✊','👌','👉','👈','👆','👇','💪','⚽','🏀','🎂','🍎'],
                    ['🐶','🐮','🍔','🎉','🎁','💊','🔑','⏱','💰','💍','🚀','🚘','🚲','🖥 ']
                ];
                return emoji_list;
            },
            send: function () {
                /*this.$refs.input.focus();
                setTimeout(function(){
                    document.body.scrollTop = document.body.scrollHeight;
                },300);*/
                this.panel = false;
                if (this.message == '') {
                    return;
                }
                this.doSend(this.message);
                this.message = '';
            },
            doSend: function (message) {
                var uniqueId = new Date().getTime();
                var that = this;
                var chatting = this.im.chatting;
                chatting[this.type + this.id].items.push({
                    mid: -uniqueId,
                    from: this.im.mine.uid,
                    to: this.id,
                    avatar: this.im.mine.avatar,
                    content: message,
                    timestamp: parseInt(uniqueId/1000),
                    sub_type: 'message',
                    uniqueId: uniqueId,
                    name: this.im.mine.nickname
                });
                im.ajax({
                    url: im.data.api.messageSend,
                    type: 'post',
                    tip: 0,
                    data: {
                        to: this.id,
                        content: message,
                        type: this.type,
                        uniqueId: uniqueId
                    },
                    success: function (res) {

                    },
                    error: function () {
                        chatting[that.type + that.id].items.pop();
                        that.message = that.message || message;
                        dialog.msg(that.$lang('发送失败，网络/服务器不可用'));
                    }
                });
                this.scrollBottom(1);
            },
            openEmotion: function () {
                if (this.panel == 'face') {
                    this.panel = false;
                    return;
                }
                this.voice = false;
                this.panel = 'face';
                if (!this.emotion_swiper) {
                    // 初始化swiper可滑动表情
                    this.$nextTick(function () {
                        this.emotion_swiper = new Swiper('#pop__emotion', {
                            pagination: '.pop__emotion-pagination',
                            paginationClickable: true
                        });
                    });
                }
            },
            openFunction: function () {
                this.panel = this.panel == 'function' ? false : 'function';
                this.voice = false;
            },
            closePanel: function () {
                this.panel = false;
            },
            selectEmotion: function (event) {
                this.message += event.target.title;
            },
            scrollBottom: function (force) {
                this.$nextTick(function () {
                    // 让input滚动到可视区域
                    /*setTimeout(function () {
                        chat.$refs.input.scrollIntoViewIfNeeded();
                    }, 500);

                    // 让input滚动到可视区域
                    setTimeout(function () {
                        chat.$refs.input.scrollIntoView();
                    }, 600);*/

                    // 如果滚动条不是拉到最底下则不滚动
                    if (force || $(".pop__chat-content").height() - ($('.pop__chat-msg-panel').scrollTop() + $('.pop__chat-msg-panel').height()) < 200) {
                        setTimeout(function () {
                            $(".pop__chat-msg-panel").scrollTop($(".pop__chat-content").height() + 1000);
                        }, 200);
                    }
                });
            },
            readImageAndSend: function (item) {
                var blob = item.getAsFile();
                var formData = new FormData();
                var name = encodeURIComponent('截图.png');
                formData.append('file', blob, name);
                im.ajax({
                    url: im.data.api.uploadImage,
                    type: 'POST',
                    data: formData,
                    //这两个设置项必填
                    contentType: false,
                    processData: false,
                    tip: 1,
                    success: function (res) {
                        if (res.code == 0) {
                            var content = '![图片](' + res.data.src + ')';
                            chat.doSend(content);
                        }
                    }
                });
            },
            paste: function (e) {
                // 添加到事件对象中的访问系统剪贴板的接口
                var clipboardData = e.clipboardData,
                    i = 0,
                    items, item, types;

                if (clipboardData) {
                    items = clipboardData.items;
                    if (!items) {
                        return;
                    }
                    item = items[0];
                    // 保存在剪贴板中的数据类型
                    types = clipboardData.types || [];
                    for (; i < types.length; i++) {
                        if (types[i] === 'Files') {
                            item = items[i];
                            break;
                        }
                    }
                    // 判断是否为图片数据
                    if (item && item.kind === 'file' && item.type.match(/^image\//i)) {
                        this.readImageAndSend(item);
                    }
                }
            },
            uploadImage: function (event) {
                this.panel = false;
                var formData = new FormData();
                var file_input = event.target;
                formData.append('file', file_input.files[0]);
                im.ajax({
                    url: im.data.api.uploadImage,
                    type: 'POST',
                    data: formData,
                    //这两个设置项必填
                    contentType: false,
                    processData: false,
                    tip: 1,
                    success: function (res) {
                        if (res.code == 0) {
                            var content = '![图片](' + res.data.src + ')';
                            chat.doSend(content);
                        }
                    }
                });
                file_input.parentNode.reset();
            },
            uploadFile: function (event) {
                this.panel = false;
                var formData = new FormData();
                var file_input = event.target;
                formData.append('file', file_input.files[0]);
                im.ajax({
                    url: im.data.api.uploadFile,
                    type: 'POST',
                    data: formData,
                    //这两个设置项必填
                    contentType: false,
                    processData: false,
                    tip: 1,
                    success: function (res) {
                        if (res.code == 0) {
                            var content = 'file[' + res.data.name + "\t" + res.data.size + '](' + res.data.src + ')';
                            chat.doSend(content);
                        }
                    }
                });
                file_input.parentNode.reset();
            },
            toggleVoice: function () {
                this.voiceBtnTips = this.$lang('按住 说话');
                this.voice = !this.voice;
                if (this.voice) {
                    if (im.supportH5Plus()) {
                        this.tryPlusAudio();
                        return;
                    }
                    this.tryBrowserAudio();
                }
            },
            tryBrowserAudio: function () {
                // 兼容旧的浏览器
                if (navigator.mediaDevices === undefined) {
                    if (im.data.mine.username == 'imtrace') {
                        alert(Object.keys2(navigator));
                    }
                    navigator.mediaDevices = {};
                }
                if (navigator.mediaDevices.getUserMedia === undefined) {
                    navigator.mediaDevices.getUserMedia = function(constraints) {
                        var getUserMedia = navigator.webkitGetUserMedia || navigator.mozGetUserMedia;
                        if (!getUserMedia) {
                            var e = new Error();
                            e.name = Vue.prototype.$lang('当前环境不支持语音');
                            return Promise.reject(e);
                        }
                        return new Promise(function(resolve, reject) {
                            getUserMedia.call(navigator, constraints, resolve, reject);
                        });
                    }
                }
                var that = this;
                navigator.mediaDevices.getUserMedia({audio: true}).then(function (stream) {
                    stream.getTracks().forEach(function(track) {
                        track.stop();
                    });
                }).catch(function (e) {
                    chat.voice = false;
                    chat.showUserMediaError(e);
                });
            },
            tryPlusAudio: function () {
                chat.recorder = plus.audio.getRecorder();
                chat.recorder.record({
                    filename:"_doc/audio/",
                    format:"mp3"
                }, function (path) {
                    console.log("path:"+path);
                }, function (e) {
                    chat.voice = false;
                    dialog.msg(e.message);
                });
                setTimeout(function () {
                    chat.recorder.stop();
                }, 50);
            },
            beginVoiceRecord: function (event) {
                event.target.posStart = event.touches[0].pageY;
                this.voiceBtnTips = this.$lang('松开 发送');
                this.voiceTips = this.$lang('手指上划，取消发送');
                if (im.supportH5Plus()) {
                    this.plusVoiceRecord();
                    return;
                }
                this.browserVoiceRecord();
            },
            browserVoiceRecord: function () {
                //创建音频
                try {
                    window.AudioContext = window.AudioContext || window.webkitAudioContext;
                    this.audio_context = new AudioContext;
                } catch (e) {
                    dialog.msg(e);
                    return;
                }
                var that = this;
                navigator.mediaDevices.getUserMedia({audio: true}).then(function (stream) {
                    that.stream = stream;
                    var input = chat.audio_context.createMediaStreamSource(stream);
                    chat.recorder = new Recorder(input);
                    chat.recorder.record();
                }).catch(function (e) {
                    chat.showUserMediaError(e);
                });
            },
            plusVoiceRecord: function () {
                chat.recorder = plus.audio.getRecorder();
                this.cancelVoiceRecord = false;
                chat.recorder.record({
                    filename:"_doc/audio/",
                    format:"mp3"
                }, function (path) {
                    console.log("recordpath:"+path);
                    if (!chat.cancelVoiceRecord) {
                        var task = plus.uploader.createUpload(im.domain()+'/'+im.data.api.uploadFile,
                            { method:"POST",blocksize:2048000,priority:100,timeout:30 },
                            function ( t, status ) {
                                // 上传完成
                                if ( status == 200 ) {
                                    var res = JSON.parse(t.responseText);
                                    if (res.code != 0) {
                                        dialog.msg(res.msg);
                                        return;
                                    }
                                    var content = 'voice(' + res.data.src + ')';
                                    chat.doSend(content);
                                } else {
                                    dialog.msg( "Upload failed: " + status );
                                }
                            }
                        );
                        task.addFile(path, {key:"file"});
                        task.start();
                    }
                }, function (e) {
                    chat.voice = false;
                    dialog.msg(e.message);
                });
            },
            browserVoiceStop: function () {
                this.recorder.stop();
                this.recorder.clear();
                this.audio_context.close();
            },
            plusRecordVoiceStop: function () {
                this.recorder.stop();
            },
            sendVoice: function (event) {
                voiceBtnTips = this.$lang('按住 说话');
                if (!this.recorder) {
                    return;
                }
                if (im.supportH5Plus()) {
                    if (this.voiceTips == this.$lang('松开手指，取消发送')) {
                        this.cancelVoiceRecord = true;
                    }
                    this.plusRecordVoiceStop();
                    this.voiceTips = '';
                    return;
                }
                if (this.voiceTips == this.$lang('松开手指，取消发送')) {
                    this.voiceTips = '';
                    this.browserVoiceStop();
                    this.voiceTips = '';
                    return;
                }
                this.voiceTips = '';
                this.recorder.stop();
                this.recorder.exportWAV(function (blob) {
                    var wavBlob = blob;
                    var formData = new FormData();
                    var wavName = encodeURIComponent('voice_recording_' + new Date().getTime() + '.wav');
                    formData.append('file', wavBlob, wavName);
                    im.ajax({
                        url: im.data.api.uploadFile,
                        type: 'POST',
                        data: formData,
                        //这两个设置项必填
                        contentType: false,
                        processData: false,
                        tip: 1,
                        success: function (res) {
                            if (res.code == 0) {
                                var content = 'voice(' + res.data.src + ')';
                                chat.doSend(content);
                            }
                        }
                    });
                    chat.recorder.clear();
                    chat.audio_context.close();
                    chat.stream && chat.stream.getTracks().forEach(function(track) {
                        track.stop();
                    });
                    chat.stream = false;
                });
            },
            cancelVoice: function (event) {
                event.preventDefault();
                var posMove = event.targetTouches[0].pageY;
                if (event.target.posStart - posMove > 50) {
                    this.voiceTips = this.$lang('松开手指，取消发送');
                    this.voiceBtnTips = this.$lang('松开 结束');
                } else {
                    this.voiceTips = this.$lang('手指上划，取消发送');
                    this.voiceBtnTips = this.$lang('松开 发送');
                }
            },
            showUserMediaError: function (e) {
                var error = e.name;
                switch (error) {
                    case 'NotAllowedError':
                    case 'PermissionDeniedError':
                    case 'NotReadableError':
                        error = e.name + ' 浏览器未获得麦克风权限';
                        break;
                    // 没接入录音设备
                    case 'NotFoundError':
                    case 'DevicesNotFoundError':
                        error = e.name + '录音设备未找到';
                        break;
                    // 其它错误
                    case 'NotSupportedError':
                        error = e.name + '该浏览器不支持录音功能';
                        break;
                }
                dialog.msg(error);
            },
            getmessage: function (scrollBottom, fn, reset) {
                if (this.messageLock || this.messageEnd || !this.id) {
                    return;
                }
                var data = {id: this.id, type: this.type};
                // 请求20条消息
                var limit = 20;
                data.limit = limit;
                if (!reset && this.mid) {
                    data.mid = this.mid;
                }
                var that = this;
                this.messageLock = true;
                // 获得最近20条消息
                im.ajax({
                    url: im.data.api.messageGet,
                    type: 'get',
                    data: data,
                    success: function (res) {
                        if (res.code == 0) {
                            if (!res.data.length || res.data.length < limit) {
                                that.messageEnd = true;
                            }
                            if (!chat.im.chatting[chat.type + chat.id]) {
                                im.syncChatting(chat.type, chat.id);
                            }
                            if (!reset) {
                                $.each(chat.im.chatting[chat.type + chat.id]['items'], function (k, v) {
                                    res.data.push(v);
                                });
                            }
                            chat.im.chatting[chat.type + chat.id].items = res.data;

                            // 修正scrollTop
                            if (fn) {
                                that.$nextTick(fn);
                            }
                            chat.scrollBottom(scrollBottom || false);
                            setTimeout(function () {
                                that.messageLock = false;
                                that.lastInsertTime = that.lastTime = 0;
                            }, 100);
                        }
                    },
                    error: function () {
                        that.messageLock = false;
                    }
                });
            },
            handleScroll: function (event) {
                this.tapMenuShow = false;
                var othis = $(event.target), top = othis.scrollTop();
                var scrollHeight = othis.prop('scrollHeight');
                var updatescrollTop = function () {
                    var scrollHeightNow = othis.prop('scrollHeight');
                    var distance = scrollHeightNow - scrollHeight;
                    distance > 0 && othis.scrollTop(distance);
                };

                if (top <= 0) {
                    this.getmessage(false, updatescrollTop);
                }
            },
            showtapMenu: function (event, type, to, mid, from, content) {
                this.supportRevoke = true;
                if (from != im.data.mine.uid) {
                    if (type == 'group') {
                        var group_info = im.getGroupFromLocal(to);
                        if (!group_info || (group_info.uid != im.data.mine.uid && !group_info.is_manager)) {
                            this.supportRevoke = false;
                        }
                    } else {
                        this.supportRevoke = false;
                    }
                }
                this.tapMenuShow = true;
                var othis = this;
                var target = $(event.currentTarget);
                this.$nextTick(function () {
                    var postion = target.position();
                    var menu = $(othis.$refs.menu);
                    othis.$refs.menu.type = type;
                    othis.$refs.menu.id = to;
                    othis.$refs.menu.mid = mid;
                    othis.$refs.menu.content = content;
                    othis.tapMenuLeft = (postion.left + target.width() / 2 - menu.width() / 2) + 'px';
                    othis.tapMenuTop = (postion.top - menu.height() - 8) + 'px';
                });
            },
            copy: function(){
                this.closeTapMenu(100);
                var text = this.$refs.menu.content;

                function selectElementText(element) {
                    if (document.selection) {
                        var range = document.body.createTextRange();
                        range.moveToElementText(element);
                        range.select();
                    } else if (window.getSelection) {
                        var range = document.createRange();
                        range.selectNode(element);
                        window.getSelection().removeAllRanges();
                        window.getSelection().addRange(range);
                    }
                }

                var element = document.createElement('DIV');
                element.textContent = text;
                document.body.appendChild(element);
                selectElementText(element);
                document.execCommand('copy');
                element.remove();
            },
            revoke: function () {
                this.closeTapMenu(100);
                if (this.$refs.menu.mid) {
                    im.ajax({
                        url: im.data.api.messageRevoke,
                        type: 'post',
                        data: {type: this.$refs.menu.type, id: this.$refs.menu.id, mid: this.$refs.menu.mid},
                        success: function () {

                        }
                    });
                }
                this.$refs.menu.mid = this.$refs.menu.type = this.$refs.menu.mid = this.$refs.menu.content = '';
            },
            closeTapMenu: function(delay) {
                if (!delay) {
                    chat.tapMenuShow = false;
                    return;
                }
                setTimeout(function(){
                    chat.tapMenuShow = false;
                }, delay);
            },
            touchStart: function (event) {
                if($('.pop__chat-tap-menu').has(event.target).length == 0) {
                    this.closeTapMenu();
                }
            },
            resizeWindow: function () {
                // 解决苹果输入框无法下沉bug
                setTimeout(function () {
                    window.scrollTo(0, document.body.scrollTop + 1);
                    document.body.scrollTop >= 1 && window.scrollTo(0, document.body.scrollTop - 1);
                }, 10)
                im.resizeWindow();
            },
            closeAtContentTip: function () {
                if (this.type != 'group') return;
                im.ajax({
                    url: im.data.api.groupMemberUpdate,
                    type: 'post',
                    tip: 0,
                    data: {gid: this.id, at: 0},
                    success: function (res) {
                    }
                });
                for (var key in im.data.group) {
                    if (im.data.group[key].gid == this.id) {
                        im.data.group[key].at = {};
                    }
                }
            },
            showAtSelection: function () {
                group_member_operation.type = 'at';
                group_member_operation.gid = chat.id;
                group_member_operation.hideCallback = function () {
                    $('#group_member_operation').css('display', 'none');
                    $('#chat').css('display', 'block');
                };
                $('#group_member_operation').css('display', 'block');
                $('#chat').css('display', 'none');
                im.ajax({
                    url: im.data.api.groupMembers,
                    type: 'get',
                    data: {gid: group_member_operation.gid, pinyin: true, exclude: im.data.mine.uid},
                    success: function (res) {
                        if (res.code == 0) {
                            group_member_operation.members = res.data;
                        }
                    }
                });
            },
            noticeReaded: function() {
                this.showNotice = 0;
                if (this.type == 'friend') return;
                var id = this.id;
                im.ajax({
                    url: im.data.api.groupMemberUpdate,
                    type: 'post',
                    tip: false,
                    data: {gid: this.id, notice_readed: 1},
                    success: function (res) {}
                });
                for (var key in im.data.group) {
                    if (im.data.group[key].gid == id) {
                        im.data.group[key].notice_readed = 1;
                    }
                }
            }
        }
    });


    var group_list = new Vue({
        el: '#group_list',
        data: {
            im: im.data
        }
    });

    // 群组列表页面
    page(im.data.baseUri + 'group/list', function (ctx) {
        if (!im.check(ctx))return;
        im.show('group_list');
    });


    // 用户详情页面
    var user_detail = new Vue({
        el: '#user_detail',
        data: {
            im: im.data,
            remarkname: '',
            username: '',
            nickname: '',
            sign: '',
            avatar: '',
            isFriend: false,
            uid: 0,
            gid: 0,
            gid_onwer: 0,
            is_manager: 0,
            accountState: 'normal',
            allowFriend: 1
        },
        methods: {
            chat: function () {
                im.chat('friend', this.uid);
            },
            deleteFriend: function () {
                var uid = this.uid;
                actionsheet.warningConfirm(this.$lang('确认删除？'), function () {
                    im.ajax({
                        url: im.data.api.friendDelete,
                        type: 'post',
                        data: {friend_uid: uid},
                        success: function (res) {
                            if (res.code == 0) {
                                im.deleteFriend(uid);
                                history.go(-2);
                            }
                        }
                    });
                });
            },
            toggleManager: function () {
                this.is_manager = this.is_manager == 1 ? 0 : 1;
                var gid = this.gid;
                var is_manager = this.is_manager;
                im.ajax({
                    url: im.data.api.groupManager,
                    type: 'post',
                    data: {gid: gid, uid: this.uid, value: is_manager},
                    success: function (res) {}
                });
            },
        }
    });

    // 用户详情页
    page(im.data.baseUri + 'user/detail/:uid', show_user_detail);
    // 群组过来的用户详情页
    page(im.data.baseUri + 'user/detail/:uid/gid/:gid', show_user_detail);
    function show_user_detail(ctx) {
        if (!im.check(ctx))return;
        var uid = ctx.params.uid;
        user_detail.uid = uid;
        user_detail.gid = ctx.params.gid || 0;
        var user_info = im.getFriendFromLocal(uid);
        if (user_info) {
            user_detail.avatar = user_info.avatar;
            user_detail.nickname = user_info.name;
            user_detail.remarkname = '';
            user_detail.username = '　';
            user_detail.isFriend = true;
            user_detail.sign = ' ';
        }
        im.ajax({
            url: im.data.api.userDetail,
            type: 'get',
            data: {uid: uid},
            success: function (res) {
                if (res.code == 0) {
                    user_detail.avatar = res.data.avatar;
                    user_detail.nickname = res.data.nickname;
                    user_detail.remarkname = res.data.remark;
                    user_detail.username = res.data.username;
                    user_detail.isFriend = res.data.is_friend;
                    user_detail.sign = res.data.sign;
                    user_detail.accountState = res.data.account_state;
                    user_detail.allowFriend = res.data.allow_friend;
                }
            }
        });
        if (user_detail.gid) {
            im.ajax({
                url: im.data.api.groupDetail,
                type: 'get',
                data: {gid: user_detail.gid, simple: 1},
                success: function (res) {
                    if (res.code == 0) {
                        user_detail.gid_onwer = res.data.uid;
                    }
                }
            });
            im.ajax({
                url: im.data.api.groupIsManager,
                type: 'get',
                data: {gid: user_detail.gid, uid: uid},
                success: function (res) {
                    if (res.code == 0) {
                        user_detail.is_manager = res.data.is_manager;
                    }
                }
            });
        }
        im.show('user_detail');
    }

    // 禁言群用户
    var forbidden = new Vue({
        el: '#forbidden',
        data: {
            im: im.data,
            selectedValue: 0,
            uid: 0,
            gid: 0
        },
        methods: {
            action: function () {
                if (!this.selectedValue) {
                    return;
                }
                var selectedValue = this.selectedValue;
                im.ajax({
                    url: im.data.api.groupForbiddenUser,
                    type: 'post',
                    data: {uid: this.uid, gid: this.gid, time: selectedValue},
                    success: function (res) {
                        if (res.code == 0) {
                            history.go(-2);
                        }
                    }
                });
            }
        }
    });

    // 禁言群用户
    page(im.data.baseUri + 'group/forbidden/:gid/:uid', function (ctx) {
        if (!im.check(ctx))return;
        forbidden.uid = ctx.params.uid;
        forbidden.gid = ctx.params.gid;
        im.show('forbidden');
    });

    // 群详情页面
    page(im.data.baseUri + 'group/detail/:gid', function (ctx) {
        if (!im.check(ctx))return;
        var gid = ctx.params.gid;
        group_detail.gid = gid;
        im.ajax({
            url: im.data.api.groupDetail,
            type: 'get',
            data: {gid: gid},
            success: function (res) {
                if (res.code == 0) {
                    group_detail.members = res.data.members;
                    group_detail.groupname = res.data.info.groupname;
                    group_detail.remark = res.data.info.remark;
                    group_detail.uid = res.data.info.uid;
                    group_detail.forbid_speaking = res.data.info.forbid_speaking;
                    group_detail.is_manager = res.data.info.is_manager;
                }
            }
        });
        im.show('group_detail');
    });

    // 群组详情页面
    var group_detail = new Vue({
        el: '#group_detail',
        data: {
            im: im.data,
            gid: 0,
            uid: 0,
            groupname: '',
            remark: '',
            forbid_speaking: 0,
            is_manager: false,
            members: []
        },
        computed: {
            isGroupOwner: function () {
                return this.uid == this.im.mine.uid;
            }
        },
        methods: {
            leaveGroup: function () {
                var gid = this.gid;
                actionsheet.warningConfirm(this.$lang('确认要退出群组么？'), function () {
                    im.ajax({
                        url: im.data.api.groupLeave,
                        type: 'post',
                        data: {gid: gid},
                        success: function (res) {
                            if (res.code == 0) {
                                im.deleteGroup(gid);
                                page(im.data.baseUri);
                            }
                        }
                    });
                });
            },
            deleteGroup: function () {
                var gid = this.gid;
                actionsheet.warningConfirm(this.$lang('确认要解散群组么？'), function () {
                    im.ajax({
                        url: im.data.api.groupDelete,
                        type: 'post',
                        data: {gid: gid},
                        success: function (res) {
                            if (res.code == 0) {
                                im.deleteGroup(gid);
                                page(im.data.baseUri);
                            }
                        }
                    });
                });
            },
            toggleForbidSpeaking: function () {
                this.forbid_speaking = this.forbid_speaking == 1 ? 0 : 1;
                var gid = this.gid;
                var forbid_speaking = this.forbid_speaking;
                im.ajax({
                    url: im.data.api.groupForbiddenAll,
                    type: 'post',
                    data: {gid: gid, value: forbid_speaking},
                    success: function (res) {}
                });
            },
            avatarLink: function (uid) {
                if (this.im.setting.member_detail == 'off' && !this.isGroupOwner && !this.is_manager) return '';
                var link = im.data.baseUri + 'user/detail/' + uid;
                if ((this.is_manager || this.isGroupOwner) && this.im.mine.uid != uid) {
                    link += '/gid/' + this.gid;
                }
                return link;
            }
        }
    });

    page(im.data.baseUri + 'group/members/:gid', function (ctx) {
        if (!im.check(ctx))return;
        group_members.reset();
        im.show('group_members');
        group_members.gid = ctx.params.gid;
        group_members.syncGroupInfo();
        group_members.nextPage();
    });

    // 群组成员页面
    var group_members = new Vue({
        el: '#group_members',
        data: {
            im: im.data,
            gid: 0,
            uid: 0,
            index: 0, // group_member表主键id
            groupname: '',
            remark: '',
            members: [],
            ended: false
        },
        computed: {
            isGroupOwner: function () {
                return this.uid == this.im.mine.uid;
            }
        },
        methods: {
            reset: function () {
                this.gid = this.uid = this.index = 0;
                this.groupname = this.remark = ''
                this.members = [];
                this.ended = false;
            },
            syncGroupInfo: function () {
                var that = this;
                im.ajax({
                    url: im.data.api.groupDetail,
                    type: 'get',
                    data: {gid: this.gid, simple:1},
                    success: function (res) {
                        if (res.code == 0) {
                            that.groupname = res.data.groupname;
                            that.remark = res.data.remark;
                            that.uid = res.data.uid;
                        }
                    }
                });
            },
            nextPage: function () {
                var that = this;
                var limit = 32;
                im.ajax({
                    url: im.data.api.groupMembers,
                    type: 'get',
                    data: {gid: this.gid, index: this.index, limit: limit},
                    success: function (res) {
                        if (res.code != 0) {
                            return;
                        }
                        var data = Object.values(res.data);
                        if (data.length < limit) {
                            that.ended = true;
                        }
                        $.each(data, function (key, item) {
                            if (that.index < item.index) {
                                that.index = item.index;
                            }
                            var nosame = true;
                            $.each(that.members, function (key2, item2) {
                                if (item2.uid == item.uid) {
                                    nosame = false;
                                }
                            });
                            nosame && that.members.push(item);
                        });
                    }
                });
            },
            avatarLink: function (uid) {
                if (this.im.setting.member_detail == 'off' && !this.isGroupOwner) return '';
                var link = im.data.baseUri + 'user/detail/' + uid;
                if (this.im.mine.uid == this.uid && uid != this.im.mine.uid) {
                    link += '/gid/' + this.gid;
                }
                return link;
            }
        }
    });


    // 编辑公告
    page(im.data.baseUri + 'group/notice/:gid', function (ctx) {
        if (!im.check(ctx))return;
        var gid = ctx.params.gid;
        var group_info = im.getGroupFromLocal(gid);
        group_notice.notice = im.htmlDecode(group_info.notice || '') || '';
        group_notice.gid = gid;
        im.show("group_notice");
    });

    // 编辑公告
    var group_notice = new Vue({
        el: '#group_notice',
        data: {
            im: im.data,
            gid: 0,
            notice: ''
        },
        methods: {
            save: function () {
                im.ajax({
                    url: im.data.api.groupUpdate,
                    type: 'post',
                    data: {gid: this.gid, notice: this.notice},
                    success: function (res) {

                    }
                });
            }
        }
    });


    // 备注等设置页面
    var setting = new Vue({
        el: '#setting',
        data: {
            im: im.data,
            title: '设置', // 设置标题
            desc: '', // 描述
            content: '', // 设置内容
            btn_name: '确定', // 按钮名称
            callback: null // 回调
        },
        methods: {
            action: function () {
                this.callback.call(this);
            }
        }
    });

    // 弹层提示
    var dialog = new Vue({
        el: '#dialog',
        data: {
            content: '', // 提示内容
            show: false, // 显示与否
            callback: null // 回调
        },
        methods: {
            msg: function (content) {
                this.content = this.$lang(content);
                this.callback = null;
                this.show = true;
            },
            confirm: function (content, callback) {
                this.content = this.$lang(content);
                this.callback = callback;
                this.show = true;
            },
            hide: function () {
                this.show = false;
            },
            action: function () {
                this.callback.call(this);
            }
        }
    });

    var actionsheet = new Vue({
        el: '#actionsheet',
        data: {
            content: '', // 提示内容
            show: false, // 显示与否
            warning: false, // 危险提示
            callback: null // 回调
        },
        methods: {
            confirm: function (content, callback) {
                this.warning = false;
                this.content = content;
                this.callback = callback;
                this.show = true;
                page(im.data.baseUri + 'actionsheet/confirm');
            },
            warningConfirm: function (content, callback) {
                this.warning = true;
                this.content = content;
                this.callback = callback;
                this.show = true;
                page(im.data.baseUri + 'actionsheet/confirm');
            },
            cancel: function () {
                history.back();
            },
            action: function () {
                this.callback.call(this);
            }
        }
    });

    page(im.data.baseUri + 'actionsheet/confirm', function (ctx) {
        if (!im.check(ctx))return;
        actionsheet.show = true;
    });

    page.exit(im.data.baseUri + 'actionsheet/*', function (ctx, next) {
        actionsheet.show = false;
        next();
    });

    // 搜索模块
    var search = new Vue({
        el: "#search",
        data: {
            im: im.data,
            searchText: '',
            applyList: [],
            showApplyList: true
        },
        methods: {
            focus: function () {
                this.$refs.input.focus();
                this.showApplyList = false;
            },
            cancel: function () {
                this.showApplyList = true;
                this.searchText = '';
            },
            clear: function () {
                this.searchText = '';
                this.focus();
            },
            blur: function () {
                if (this.searchText) {
                    return;
                }
                this.cancel();
            },
            operationName: function (operation) {
                if (operation == 'not_operated') {
                    return '<a href="javascript:;" class="pop__btn-primary-mini">'+this.$lang('查看')+'</a>';
                } else if (operation == 'agree') {
                    return '<label>'+this.$lang('已同意')+'</label>';
                } else if (operation == 'refuse') {
                    return '<label>'+this.$lang('已拒绝')+'</label>';
                }
                return operation;
            },
            search: function () {
                var that = this;
                im.ajax({
                    url: im.data.api.getUserByName,
                    type: 'get',
                    msg: false,
                    data: {username: this.searchText},
                    success: function (res) {
                        if (res.code == 0 && typeof res.data.uid !== 'undefined') {
                            page(im.data.baseUri + 'user/detail/' + res.data.uid);
                        } else {
                            dialog.msg(that.$lang('未找到该用户'));
                        }
                    }
                });
            },
            syncApplyList: function () {
                im.ajax({
                    url: im.data.api.friendApplyList,
                    type: 'get',
                    success: function (res) {
                        if (res.code == 0) {
                            search.applyList = res.data;
                        }
                    }
                });
            }
        }
    });

    page(im.data.baseUri + 'friend/search', function (ctx) {
        if (!im.check(ctx))return;
        search.syncApplyList();
        im.show("search");
    });

    // 群组详情页面
    var mine_detail = new Vue({
        el: '#mine_detail',
        data: {
            im: im.data
        }
    });

    page(im.data.baseUri + 'mine/detail', function (ctx) {
        if (!im.check(ctx))return;
        im.show("mine_detail");
    });

    // 备注等设置页面
    var password = new Vue({
        el: '#password',
        data: {
            im: im.data,
            password_old: '',
            password1: '',
            password2: ''
        },
        methods: {
            update: function () {
                var that = this;
                if (this.password1 == '' || this.password2 == '' || this.password_old == '') {
                    dialog.msg(this.$lang('密码不能为空'));
                    return;
                }
                if (this.password1 != this.password2) {
                    dialog.msg(this.$lang('两次密码输入不一致'));
                    return;
                }
                im.ajax({
                    url: im.data.api.updatePassword,
                    type: 'post',
                    data: {password_old: this.password_old, password1: this.password1, password2:this.password2},
                    success: function (res) {
                        if (res.code == 0) {
                            that.password_old = that.password1 = that.password2 = '';
                            history.back();
                        }
                    }
                });
            }
        }
    });

    page(im.data.baseUri + 'setting/password', function (ctx) {
        if (!im.check(ctx))return;
        im.show("password");
    });

    // 头像设置
    var set_avatar = new Vue({
        el: '#set_avatar',
        data: {
            im: im.data
        },
        methods: {
            uploadAvatar: function (event) {
                var formData = new FormData();
                var file_input = event.target;
                formData.append('file', file_input.files[0]);
                im.ajax({
                    url: im.data.api.uploadAvatar,
                    type: 'POST',
                    data: formData,
                    //这两个设置项必填
                    contentType: false,
                    processData: false,
                    tip: 1,
                    success: function (res) {
                        if (res.code == 0) {
                            var src = res.data.src;
                            im.ajax({
                                url: im.data.api.userUpdate,
                                type: 'post',
                                data: {
                                    avatar: src
                                },
                                success: function (res) {
                                    im.data.mine.avatar = src;
                                }
                            });
                        }
                    }
                });
                file_input.parentNode.reset();
            }
        }
    });

    page(im.data.baseUri + 'setting/avatar', function (ctx) {
        if (!im.check(ctx))return;
        im.show("set_avatar");
    });

    // 显示二维码
    var qrcode = new Vue({
        el: '#qrcode',
        data: {
            im: im.data,
            tips: '',
            avatar: '',
            name: ''
        },
        methods: {
            create: function (url, tips, avatar, name) {
                $("#qrcode-img").empty();
                this.tips = tips;
                this.avatar = avatar;
                this.name = name;
                new QRCode(document.getElementById("qrcode-img"), url);
            }
        }
    });

    page(im.data.baseUri + 'setting/qrcode', function (ctx) {
        if (!im.check(ctx))return;
        qrcode.create(im.domain()+im.data.baseUri+'user/detail/'+im.data.mine.uid, '扫码加我为好友', im.data.mine.avatar, im.data.mine.nickname);
        im.show("qrcode");
    });

    page(im.data.baseUri + 'group/qrcode/:gid', function (ctx) {
        if (!im.check(ctx))return;
        var gid = ctx.params.gid;
        var group_info = im.getGroupFromLocal(gid);
        qrcode.create(im.domain()+im.data.baseUri+'group/chat/'+gid, '群二维码', group_info.avatar, group_info.name);
        im.show("qrcode");
    });

    // 扫描二维码
    var qrcode_scan = new Vue({
        el: '#qrcode_scan',
        data: {
            im: im.data,
        },
        methods: {
            start: function () {
                if (!window.plus) {
                    dialog.msg(this.$lang('当前环境不支持扫描二维码'));
                    return;
                }
                var that = this;
                setTimeout(function () {
                    if (!this.scan) {
                        that.scan = new plus.barcode.Barcode('qrcode_scan_div');
                        that.scan.onmarked = function (type, result) {
                            var text = '未知: ';
                            switch(type) {
                                case plus.barcode.QR:
                                    text = 'QR: ';
                                    break;
                                case plus.barcode.EAN13:
                                    text = 'EAN13: ';
                                    break;
                                case plus.barcode.EAN8:
                                    text = 'EAN8: ';
                                    break;
                            }
                            that.scan.close();
                            console.log('qrcode scan result', text+':'+result);
                            var domain = im.domain();
                            if (result.indexOf(domain) == 0) {
                                if (/group\/chat\/(\d+)/.exec(result)) {
                                    var gid = RegExp.$1;
                                    im.ajax({
                                        url: im.data.api.groupJoin,
                                        type: 'post',
                                        data: {gid: gid},
                                        success: function (res) {
                                            if (res.code == 0) {
                                                page.replace(result.replace(domain, ''));
                                            }
                                        }
                                    });
                                } else {
                                    page.replace(result.replace(domain, ''));
                                }
                            } else {
                                dialog.msg(text+':'+result);
                            }
                        };
                        that.scan.onerror = function ( error ) {//失败回调
                            dialog.msg(error);
                        };
                    }
                    that.scan.start();
                    console.log('scan start');
                }, 300);
            },
            close: function () {
                this.scan && this.scan.close();
            }
        }
    });

    page(im.data.baseUri + 'qrcode/scan', function (ctx) {
        if (!im.check(ctx))return;
        im.show("qrcode_scan");
        qrcode_scan.start();
    });


    page.exit(im.data.baseUri + 'qrcode/scan', function (ctx, next) {
        qrcode_scan.scan && qrcode_scan.scan.close();
        next();
    });

    page(im.data.baseUri + 'setting/nickname', function (ctx) {
        if (!im.check(ctx))return;
        im.setting('设置名字', '', im.data.mine.nickname, '完成', function () {
            im.ajax({
                url: im.data.api.userUpdate,
                type: 'post',
                data: {nickname: setting.content},
                success: function (res) {
                    if (res.code == 0) {
                        im.data.mine.nickname = im.htmlEncode(setting.content);
                        history.back();
                    }
                }
            });
        });
    });

    page(im.data.baseUri + 'setting/sign', function (ctx) {
        if (!im.check(ctx))return;
        im.setting('设置个性签名', '', im.data.mine.sign, '完成', function () {
            im.ajax({
                url: im.data.api.userUpdate,
                type: 'post',
                data: {sign: setting.content},
                success: function (res) {
                    if (res.code == 0) {
                        im.data.mine.sign = im.htmlEncode(setting.content);
                        history.back();
                    }
                }
            });
        });
    });

    var setting_others = new Vue({
        el: "#setting_others",
        data: {
            im: im.data,
            prompt_tone: 'on'
        },
        computed: {
            languageName:function(){
                var map = {'zh-CN':'简体中文', en:'English'};
                return map[this.im.language] || '简体中文';
            }
        },
        methods: {
            togglePromptTone: function () {
                this.prompt_tone = this.prompt_tone == 'on' ? 'off' : 'on';
                var prompt_tone = this.prompt_tone;
                im.ajax({
                    url: im.data.api.userUpdate,
                    type: 'post',
                    data: {prompt_tone: prompt_tone},
                    success: function (res) {
                        if (res.code == 0) {
                            im.data.mine.prompt_tone = prompt_tone;
                        }
                    }
                });
            },
            logout: function () {
                var data = {logout_uid: im.data.mine.uid};
                if (typeof plus != 'undefined' && plus.push) {
                    var client_info = plus.push.getClientInfo();
                    data.cid = client_info.clientid;
                }
                im.ajax({
                    url: im.data.api.logout,
                    type: 'POST',
                    data: data,
                    tip: 0,
                    success: function (res) {
                        im.backToPath = im.data.baseUri;
                        history.back();
                        setTimeout(function () {
                            if (im.connecter) {
                                try {
                                    im.connecter.unsubscribe('user-' + im.data.mine.uid);
                                    $.each(im.data.group, function (k, item) {
                                        im.unlistenGroup(item.gid);
                                    });
                                    im.connectionInited = false;
                                    im.connecter.disconnect();
                                }catch(e){console.log(e)}
                            }
                            im.data.chatting = im.data.friend = im.data.group = [];
                            im.data.mine = {};
                            chat.id = 0;
                            home.hasSyncAddress = false;
                            home.tab = 'chatting';
                            home.syncData();
                        }, 500);
                    }
                });
            }

        }
    });

    page(im.data.baseUri + 'setting/others', function (ctx) {
        if (!im.check(ctx))return;
        setting_others.prompt_tone = im.data.mine.prompt_tone;
        im.show('setting_others');
    });

    // 选择语言
    var language = new Vue({
        el: '#language',
        data: {
            im: im.data,
            selectedValue: 0
        },
        methods: {
            action: function () {
                if (!this.selectedValue) {
                    return;
                }
                localStorage.setItem('language', this.selectedValue);
                im.data.language= this.selectedValue;
                history.back();
            }
        }
    });

    // 禁言群用户
    page(im.data.baseUri + 'setting/language', function (ctx) {
        if (!im.check(ctx))return;
        language.selectedValue = im.data.language;
        im.show('language');
    });

    // 发送好友申请页面
    page(im.data.baseUri + 'friend/send_apply/:uid', function (ctx) {
        if (!im.check(ctx))return;
        im.setting(Vue.prototype.$lang('发送验证'), Vue.prototype.$lang('你需要发送验证申请，等对方通过'), Vue.prototype.$lang('我是') + im.data.mine.nickname, Vue.prototype.$lang('发送'), function () {
            im.ajax({
                url: im.data.api.friendApply,
                type: 'post',
                data: {friend_uid: ctx.params.uid, postscript: setting.content},
                success: function (res) {
                    if (res.code == 0) {
                        history.back();
                    }
                }
            });
        });
    });

    var apply_detail = new Vue({
        el: "#apply_detail",
        data: {
            im: im.data,
            nid: 0,
            nickname: '',
            username: '',
            avatar: '',
            postScript: '',
            operation: ''
        },
        methods: {
            agree: function () {
                im.ajax({
                    url: im.data.api.friendAgree,
                    type: 'post',
                    data: {nid: this.nid},
                    success: function (res) {
                        if (res.code == 0) {
                            home.syncApplyCount();
                            im.syncAddress();
                            history.back();
                        }
                    }
                });
            },
            refuse: function () {
                im.ajax({
                    url: im.data.api.friendRefuse,
                    type: 'post',
                    data: {nid: this.nid},
                    success: function (res) {
                        if (res.code == 0) {
                            home.syncApplyCount();
                            history.back();
                        }
                    }
                });
            }
        }
    });

    page(im.data.baseUri + 'apply/detail/:nid', function (ctx) {
        if (!im.check(ctx))return;
        var nid = ctx.params.nid;
        apply_detail.username = apply_detail.nickname = apply_detail.avatar = apply_detail.postScript = apply_detail.operation = '';
        apply_detail.nid = nid;
        im.ajax({
            url: im.data.api.friendApplyDetail,
            type: 'get',
            data: {nid: nid},
            success: function (res) {
                if (res.code == 0) {
                    apply_detail.avatar = res.data.avatar;
                    apply_detail.nickname = res.data.nickname;
                    apply_detail.username = res.data.username;
                    var apply_data = res.data.data ? JSON.parse(res.data.data) : {};
                    apply_detail.postScript = apply_data.postscript || '';
                    apply_detail.operation = res.data.operation;
                }
            }
        });
        im.show('apply_detail');
    });

    // 群成员添加/删除
    var group_member_operation = new Vue({
        el: "#group_member_operation",
        data: {
            im: im.data,
            gid: 0,
            type: 'add',
            members: [],
            selectedItems: [],
            hideCallback: null
        },
        methods: {
            hide: function () {
                if (this.hideCallback) {
                    this.hideCallback();
                    return;
                }
                history.back(-1);
            },
            reset: function () {
                this.hideCallback = null;
                this.$refs.form.reset();
                this.selectedItems = [];
            },
            action: function () {
                if (this.type == 'create') {
                    im.ajax({
                        url: im.data.api.groupCreate,
                        type: 'post',
                        data: {members: this.selectedItems},
                        success: function (res) {
                            if (res.code == 0) {
                                var gid = res.data.gid;
                                im.addChatting({
                                    id: gid,
                                    name: res.data.groupname,
                                    avatar: res.data.avatar,
                                    type: 'group',
                                    unread_count: 0,
                                    items: [],
                                    top: 0
                                });
                                im.listenGroup(res.data.gid);
                                im.chat('group', res.data.gid);
                            }
                        }
                    });
                    this.reset();
                    return;
                } else if (this.type == 'at') {
                    var tmp_uid = 0;
                    var at_string = '';
                    if (this.selectedItems.length) {
                        for (var char in this.members) {
                            for (var k in this.members[char]) {
                                for (var i in this.selectedItems) {
                                    tmp_uid = this.selectedItems[i];
                                    if (tmp_uid == this.members[char][k]['uid']){
                                        at_string += '@['+this.members[char][k]['nickname']+']('+tmp_uid+') '
                                    }
                                }
                            }
                        }
                    }
                    if (at_string) {
                        chat.message = chat.message.replace(/@$/, at_string);
                    }
                    this.reset();
                    $('#group_member_operation').css('display', 'none');
                    $('#chat').css('display', 'block');
                    return;
                }
                var gid = this.gid;
                im.ajax({
                    url: this.type == 'add' ? im.data.api.groupMemberAdd : im.data.api.groupMemberDelete,
                    type: 'post',
                    data: {members: this.selectedItems, gid: gid},
                    success: function (res) {
                        page.replace(im.data.baseUri + 'group/chat/' + gid);
                    }
                });
                this.reset();
            },
            scrollIntoView: im.scrollIntoView
        }
    });

    page(im.data.baseUri + 'group/create', function (ctx) {
        if (!im.check(ctx))return;
        group_member_operation.type = 'create';
        group_member_operation.gid = ctx.params.gid;
        if (!home.hasSyncAddress) {
            im.syncAddress(function () {
                group_member_operation.members = im.data.friend;
            });
            home.hasSyncAddress = true;
        } else {
            group_member_operation.members = im.data.friend;
        }
        im.show('group_member_operation');
    });

    // 添加群成员
    page(im.data.baseUri + 'group/memberadd/:gid', function (ctx) {
        if (!im.check(ctx))return;
        group_member_operation.type = 'add';
        group_member_operation.gid = ctx.params.gid;
        im.show('group_member_operation');
        im.ajax({
            url: im.data.api.groupMembers,
            type: 'get',
            data: {gid: ctx.params.gid},
            success: function (res) {
                if (res.code == 0) {
                    var members = res.data;
                    var diff = {};
                    var func = function () {
                        $.each(im.data.friend, function (char, items) {
                            var tmp = [];
                            $.each(items, function (k, item) {
                                var uid = item['uid'];
                                if (!members[uid]) {
                                    tmp.push(item);
                                }
                            });
                            if (tmp.length) {
                                diff[char] = tmp;
                            }
                        });
                        group_member_operation.members = diff;
                    };
                    if (!home.hasSyncAddress) {
                        im.syncAddress(func);
                        return;
                    }
                    func();
                }
            }
        });
    });

    // 删除群成员
    page(im.data.baseUri + 'group/memberdel/:gid', function (ctx) {
        if (!im.check(ctx))return;
        group_member_operation.type = 'del';
        group_member_operation.gid = ctx.params.gid;
        im.show('group_member_operation');
        im.ajax({
            url: im.data.api.groupMembers,
            type: 'get',
            data: {gid: ctx.params.gid, pinyin: true, exclude: im.data.mine.uid},
            success: function (res) {
                if (res.code == 0) {
                    group_member_operation.members = res.data;
                }
            }
        });
    });

    // 消息组件
    Vue.component('chat-message', {
        props: ['from', 'name', 'content', 'time', 'avatar', 'mid', 'im', 'sub_type'],
        data: function () {
            return {'src': '', state: 'paused', duration: 0, htmlContent: ''};
        },
        computed: {
            messageType: function () {
                content = this.content.replace(/\n/g, '<br>').replace(/ /g, '&nbsp;').replace(/\[表情(\d+)\]/g, '<img class="pop__chat-msg-face" src="/static/h5/img/emotion/face01/$1.png" title="[表情$1]"/>');
                content = content.replace(/\{POPBASEURI\}/g, im.data.baseUri);
                this.htmlContent = content;
                var url, info, message_type = 'pop__chat-msg-text';

                if (/^audioCall\[\]$/.exec(this.content)) {
                    return 'pop__chat-msg-voice-call';
                } else if (/^videoCall\[\]$/.exec(this.content)) {
                    return 'pop__chat-msg-video-call';
                } else if (/^voice\(([^\)]+?)\)$/.exec(this.content) || /^voice\[\d+?\]\(([^\)]+?)\)$/.exec(this.content)) {
                    this.src = RegExp.$1;
                    return 'pop__chat-msg-voice';
                } else if (info = /\!\[.*?\]\(([^\)]+?)\)/.exec(content)) {
                    url = info[1];
                    if(im.isDangerousUrl(url)) {
                        return message_type;
                    }
                    message_type = 'pop__chat-msg-picture';
                    content = '<img src="'+url+'" />';
                } else if (info = /^file\[(.*?)[\t|\|](.*?)]\((.+?)\)$/.exec(content)) {
                    // 文件 file[文件名\tescape](文件下载地址)
                    var file_name = info[1];
                    var file_info = info[2];
                    url = info[3];
                    if(im.isDangerousUrl(url)) {
                        return message_type;
                    }

                    message_type = 'pop__chat-msg-file';
                    var index = file_name.lastIndexOf(".");
                    var ext = index ? file_name.substring(index + 1, file_name.length).toUpperCase() : "file";
                    ext = ext.length > 3 ? ext.substring(0, 4).toLowerCase() : ext;
                    if (ext == 'MP4' || ext == 'MOV' || ext == '3GP') {
                        message_type = 'pop__chat-msg-video';
                        content = '<video src="'+url+'"></video>';
                    } else {
                        content = '<div class="pop__chat-msg-file-cover">\
                         <i class="pop__chat-msg-icon">' + ext + '</i>\
                      </div>\
                      <div class="pop__chat-msg-file-info">\
                          <span class="pop__chat-msg-file-name"><a href="' + url + '" download="' + file_name + '">' + file_name + '</a></span>\
                          <span class="pop__chat-msg-file-size">' + file_info + '</span>\
                      </div>';
                    }
                } else if (/\[.*?\]\(([^\)]+?)\)/.test(content)) {
                    // 替换a连接，为了避免javascript注入，必须以http或者/开头，否则认为是无效连接
                    content = content.replace(/\[(.*?)\]\(((?=http|\/\/)[^\)]+?)\)/g, '<a href="$2" target="_blank">$1</a>');
                    content = content.replace(/\[(.*?)\]\((\/[^\)]+?)\)/g, '<a href="$2">$1</a>');
                } else if (/((([A-Za-z]{3,9}:(?:\/\/)?)(?:[\-;:&=\+\$,\w]+@)?[A-Za-z0-9\.\-]+|(?:www\.|[\-;:&=\+\$,\w]+@)[A-Za-z0-9\.\-]+)((?:\/[\+~%\/\.\w\-_]*)?\??(?:[\-\+=&;%@\.\w_]*)#?(?:[\.\!\/\\\w]*))?)/.test(content)) {
                    content = content.replace('&nbsp;', ' ').replace(/((([A-Za-z]{3,9}:(?:\/\/)?)(?:[\-;:&=\+\$,\w]+@)?[A-Za-z0-9\.\-]+|(?:www\.|[\-;:&=\+\$,\w]+@)[A-Za-z0-9\.\-]+)((?:\/[\+~%\/\.\w\-_]*)?\??(?:[\-\+=&;%@\.\w_]*)#?(?:[\.\!\/\\\w]*))?)/ig, function(item){
                        return "<a href='"+item+"' target='_blank'>"+item+"</a>";
                    });

                    content = content.replace('  ', '&nbsp;&nbsp;');
                }
                content = content.replace(/@\[(.+?)\]\((\d+)\)/g, '<em>@$1</em>');

                content = linkifyHtml(content);

                this.htmlContent = content;
                return message_type;
            },
            type: function () {
                return chat.type;
            },
            avatarLink: function () {
                if (this.type == 'group' && im.data.setting.member_detail == 'off' && !this.isGroupOwner) {
                    return '';
                }
                var link = im.data.baseUri + 'user/detail/' + this.from;
                if (this.type == 'group' && this.im.mine.uid != this.from) {
                    if (this.isGroupOwner) {
                        link += '/gid/' + chat.id;
                    }
                }
                return link;
            },
            isGroupOwner: function () {
                if (this.type != 'group') return false;
                var group_info = im.getGroupFromLocal(this.to);
                return group_info && group_info.uid == im.data.mine.uid
            },
            to: function () {
                return chat.id;
            }
        },
        methods: {
            play: function () {
                if (this.messageType != 'pop__chat-msg-voice') {
                    return;
                }
                $.each($('audio'), function (k, item) {
                    !item.paused && item.pause();
                });
                var voice = this.$refs.voice;
                if (voice.paused) {
                    voice.currentTime = 0;
                    voice.play();
                }
            },
            setState: function (e) {
                this.state = e.type == 'play' ? 'running' : 'paused';
            },
            durationChange: function () {
                var voice = this.$refs.voice;
                if (voice) {
                    this.duration = Math.ceil(voice.duration);
                    if (this.duration < 0 || this.duration == Infinity) {
                        this.duration = 0;
                    }
                }
            },
            showtapMenu: function (event, type, to, mid, from, content) {
                chat.showtapMenu(event, type, to, mid, from, content);
                return false;
            },
            textContent: function () {
                return im.textContent(this.content);
            },
            noticeContent: function () {
                if (this.type == 'group' && im.data.setting.member_detail == 'off' && !this.isGroupOwner) {
                    return this.textContent();
                }
                return this.htmlContent;
            },
            at: function (uid, name, event) {
                if (this.type != 'group') return;
                chat.message = chat.message + ' @['+name+']('+uid+') ';
                var target = $(event.target);
                var url = target.attr('routeUrl');
                target.attr('routeUrl', '');
                setTimeout(function () {
                    target.attr('routeUrl', url);
                }, 1000);
            }
        },
        template: '<li v-if="sub_type!=\'notice\'" :class="{\'pop__chat-msg-me\':im.mine.uid==from, \'pop__chat-msg-others\':im.mine.uid!=from}" :key="mid">\
                      <span v-if="im.mine.uid!=from" class="pop__chat-msg-avatar" ><img @contextmenu.stop.prevent @longTap.stop.prevent="at(from, name, $event)" :src="avatar" :routeUrl="avatarLink"/></span>\
                      <div class="pop__chat-msg-content">\
                        <p class="pop__chat-msg-author" v-if="type==\'group\'" v-html="name"></p>\
                        <div class="pop__chat-msg-msg" :class="messageType" @click="play" @contextmenu.stop.prevent @longTap.stop.prevent="showtapMenu($event,type,to,mid,from, content)">\
                            <span v-if="messageType==\'pop__chat-msg-voice\'">\
                                <template v-if="im.mine.uid == from">\
                                    <span class="pop__voice-box pop__float-right pop__route180" :class="{\'pop__voice-playing\':state==\'running\'}"></span>\
                                    <span class="pop__voice-body pop__float-left"><span v-if="duration!=0">{{duration}}"</span></span>\
                                </template>\
                                <template v-else>\
                                    <span class="pop__voice-body pop__float-right pop__text-right">{{duration}}"</span>\
                                    <span class="pop__voice-box pop__float-left" :style="{\'animation-play-state\':state}" :class="{\'pop__voice-playing\':state==\'running\'}"></span>\
                                </template>\
                                <audio preload="auto" hidden="true" ref="voice" @play="setState" @ended="setState" @pause="setState" @abort="setState" @error="setState" @stalled="setState" @empted="setState" @durationchange="durationChange"><source :src="src" type="audio/mpeg"></audio>\
                            </span>\
                            <span v-else-if="this.messageType==\'pop__chat-msg-video-call\'">\
                                {{Vue.prototype.$lang("视频通话")}} <span class="pop__layui-icon">&#xeba7</span>\
                            </span>\
                            <span v-else-if="this.messageType==\'pop__chat-msg-voice-call\'">\
                                {{Vue.prototype.$lang("语音通话")}} <span class="pop__layui-icon">&#xeba5</span>\
                            </span>\
                            <span v-else="this.messageType!=\'pop__chat-msg-voice\'" v-html="htmlContent"></span>\
                        </div>\
                      </div>\
                      <span v-if="im.mine.uid==from" class="pop__chat-msg-avatar" :routeUrl="avatarLink"><img :src="avatar" /></span>\
                  </li>\
                  <li v-else-if="sub_type==\'notice\' && messageType" class="pop__chat-msg-notice"><span v-html="noticeContent()"></span></li>'
    });

    // 登录页面
    page(im.data.baseUri + 'user/login', function (ctx) {
        if (!im.check(ctx))return;
        im.syncSetting();
        im.show('login');
    });

    // 登录页面
    page(im.data.baseUri + 'user/join', function (ctx) {
        if (!im.check(ctx))return;
        im.syncSetting();
        im.show('join');
    });

    // 好友备注页面
    page(im.data.baseUri + 'friend/remark/:uid', function (ctx) {
        if (!im.check(ctx))return;
        var uid = ctx.params.uid;
        im.setting('设置备注', '备注名', user_detail.remarkname || user_detail.nickname, '完成', function () {
            im.ajax({
                url: im.data.api.friendRemark,
                type: 'post',
                data: {friend_uid: uid, remark: setting.content},
                success: function (res) {
                    if (res.code == 0) {
                        im.updateFriend(uid, {name: im.htmlEncode(setting.content)});
                        history.back();
                    }
                }
            });
        });
    });

    // 群备注页面
    page(im.data.baseUri + 'group/remark/:gid', function (ctx) {
        if (!im.check(ctx))return;
        var gid = ctx.params.gid;
        im.setting('设置备注', '备注名', group_detail.remark || group_detail.groupname, '完成', function () {
            im.ajax({
                url: im.data.api.groupRemark,
                type: 'post',
                data: {gid: gid, remark: setting.content},
                success: function (res) {
                    if (res.code == 0) {
                        if (im.data.chatting['group' + gid]) {
                            im.data.chatting['group' + gid]['name'] = im.htmlEncode(setting.content);
                        }
                        history.back();
                    }
                }
            });
        });
    });

    // 修改群名称页面
    page(im.data.baseUri + 'group/rename/:gid', function (ctx) {
        if (!im.check(ctx))return;
        var gid = ctx.params.gid;
        im.setting('设置群名称', '名称', group_detail.groupname, '完成', function () {
            im.ajax({
                url: im.data.api.groupUpdate,
                type: 'post',
                data: {gid: gid, groupname: setting.content},
                success: function (res) {
                    if (res.code == 0) {
                        if (im.data.chatting['group' + gid]) {
                            im.data.chatting['group' + gid]['name'] = im.htmlEncode(setting.content);
                        }
                        history.back();
                    }
                }
            });
        });
    });

    // 当在聊天页面退出时直接回退到主面板
    page.exit(im.data.baseUri + '*/chat/*', function (ctx, next) {
        chat.reset();
        if (im.isback) {
            im.backToPath = im.data.baseUri;
        }
        chat.tapMenuShow = false;
        $(".pop__video-view .pop__close").trigger("click");
        if ($(".pop__img-view").css('display') == 'block') $(".pop__img-view").trigger("click");
        next();
    });

    var toast = new Vue({
        el: '#toast',
        data: {
            dataPosting: false
        }
    });

    // 点击有routeUrl标签的元素时跳转到对应页面
    $(function () {
        $('.pop__panel').on("click", "*[routeUrl]", function (e) {
            var routeurl = $(this).attr('routeUrl');
            if (!routeurl) return;
            page(routeurl);
        });
    });

    // 点击有replaceUrl标签的元素时跳转到对应页面
    $(function () {
        $('.pop__panel').on("click", "*[replaceUrl]", function (e) {
            var routeurl = $(this).attr('replaceUrl');
            if (!routeurl) return;
            page.replace(routeurl);
        });
    });

    // 当点击了返回或者回退时
    $(window).on('popstate', function () {
        im.isback = true; // 标记回退中
    });


    setInterval(function () {
        im.autoUpdateTime();
    }, 60000);

    $(function () {
        var curIndex = 0, img_view_swiper;
        $(".pop__chat-content").on("click", ".pop__chat-msg-picture", function () {
            if (chat.tapMenuShow) {
                return;
            }
            var html = "", _src = $(this).find("img").attr("src");

            $(".pop__chat-content li .pop__chat-msg-picture").each(function (i, item) {
                $(this).find('img').css('max-height', im.height+'px');
                html += '<div class="swiper-slide"><div class="swiper-zoom-container">' + $(this).html() + '</div></div>';
                if ($(this).find("img").attr("src") == _src) {
                    curIndex = i;
                }
            });
            $(".pop__img-view-container .swiper-wrapper").html(html);
            $(".pop__img-view").show();

            img_view_swiper = new Swiper('.pop__img-view-container', {
                pagination: false,
                paginationClickable: true,
                zoom: true,
                observer: true,
                observeParents: true,
                initialSlide: curIndex
            });
        });
        // 关闭预览
        $(".pop__img-view").on("click", function (e) {
            var that = $(this);
            img_view_swiper.destroy(true, true);
            $(".pop__img-view-container .swiper-wrapper").html('');
            that.hide();
        });
    });

    // 视频
    $(function () {
        var video = document.getElementById('pop__video');
        $(".pop__chat-content").on("click", ".pop__chat-msg-video", function () {
            video.src = $(this).find("video").attr("src");
            $(".pop__video-view").show();
            if (video.paused) {
                video.play();
            } else {
                video.pause();
            }
        });
        video.addEventListener("ended", function () {
            video.currentTime = 0;
        }, false);

        $(video).on('click', function (e) {
            e.stopPropagation();
        });

        // 关闭预览
        $(".pop__video-view").on("click", function () {
            $(".pop__video-view").hide();
            video.currentTime = 0;
            video.pause();
        });

        // 进入全屏、退出全屏
        video.addEventListener("x5videoenterfullscreen", function () {
            console.log("进入全屏");
        }, false);
        video.addEventListener("x5videoexitfullscreen", function () {
            $(".pop__video-view .pop__close").trigger("click");
        }, false);
    });

    // 窗口大小变化时调整页面相关尺寸让页面不会有滚动条
    $(document).ready(function ($) {
        im.resizeWindow();
        $(window).resize(im.resizeWindow);
        im.autoPlayPromptTone();
    });

    page();
})();

// 离线推送相关
// H5 plus事件处理
function plusReady(){
    //监听click事件，用户从消息中心点击触发的
    plus.push.addEventListener("click", function (msg) {
        console.log("You clicked: " + msg.title); //推送消息标题
        console.log("You clicked: " + msg.content); //推送消息内容
        //根据payload传递过来的数据，打开一个详情
        var payload = msg.payload;
        console.log(JSON.stringify(msg));
        if (payload) {
            // payload 按照规范是 Object，但实际推送过来有可能是 String，需要多一步处理；
            if (typeof payload === 'string') {
                payload = JSON.parse(payload);
            }
            if (typeof payload === 'object' && payload.path) {
                if(payload.path.indexOf('/') === 0) {
                    payload.path = payload.path.substr(1);
                }
                console.log(im.data.baseUri + payload.path);
                page(im.data.baseUri + payload.path);
            }
        }
    }, false);

    //监听receive事件
    plus.push.addEventListener("receive", function (msg) {
        console.log("recieve title: " + msg.title); //推送消息标题
        console.log("recieve content: " + msg.content); //推送消息内容
    }, false);

}
if(window.plus){
    plusReady();
}else{
    document.addEventListener('plusready', plusReady, false);
}